
local sdebug = CV_RegisterVar({
	name = "silverdebug",
	defaultvalue = 0,
	possiblevalue = CV_OnOff
})

rawset(_G, "silv_debug", function() return sdebug.value end)
rawset(_G, "silv_dprint", function(s)
	if silv_debug() then
		print(s)
	end
end)


for i = 1, 4
	freeslot("sfx_thrw"..i)
end
for i = 1, 3
	freeslot("sfx_skill"..i)
end
freeslot("sfx_skills")
freeslot("sfx_silrip")

rawset(_G, "SILVER_MAX_ENERGY", 350)
rawset(_G, "SILVER_REGEN_RATE", 2)

-- SOUND EFFECTS:
freeslot("sfx_float", "sfx_cancel", "sfx_levi")	-- float
freeslot("sfx_psybst") -- psyboost

-- BOT BUBBLES:
freeslot("SPR_SFLI", "S_SILV_WARNINGINDICATOR", "S_SILV_TIREDINDICATOR")
states[S_SILV_WARNINGINDICATOR] = {SPR_SFLI, A|FF_ANIMATE|FF_FULLBRIGHT, -1, nil, 3, 2, S_SILV_WARNINGINDICATOR}
states[S_SILV_TIREDINDICATOR] = {SPR_SFLI, E|FF_ANIMATE|FF_FULLBRIGHT, -1, nil, 1, 6, S_SILV_TIREDINDICATOR}

-- TELEKINESIS LOCKON:
freeslot("SPR_SLCK", "S_LOCKON_SILV")
states[S_LOCKON_SILV] = {SPR_SLCK, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

-- TELEKINESIS AURA:
freeslot("SPR_FRAG")
for i = 1, 5
	freeslot("S_FRAG"..i)
end
local trans = {TR_TRANS50, TR_TRANS60, TR_TRANS70, TR_TRANS80, TR_TRANS80}
for i = 0,4
	states[S_FRAG1+i]	= {SPR_FRAG, i|FF_FULLBRIGHT|trans[i+1], 3, nil, 0, 0, i<3 and S_FRAG2+i or S_NULL}
end

freeslot("SPR_HOWL", "S_HOWL1", "S_HOWL2", "S_HOWL3")
local tlookup = {TR_TRANS50, TR_TRANS70, TR_TRANS80}
for i = 0, 2 do
	states[S_HOWL1+i] = {SPR_HOWL, i|tlookup[i+1]|FF_PAPERSPRITE, 2, nil, 0, 0, i < 2 and S_HOWL2+i or S_NULL}
end

-- IDLE:
freeslot("SPR_RGRB")

-- shield abilities:
freeslot("SPR_KLIT")

-- TELEKINESIS STATES
freeslot("MT_PSYHITBOX", "S_SILVTHROW")
mobjinfo[MT_PSYHITBOX] = {
	-1,
	S_INVISIBLE,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	64 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
	S_NULL
}


-- VERY SPECIFIC EGG ROBO SPAWNER HELPER
freeslot("MT_EGGROBO_SPAWNHELPER", "S_EGGROBO_SPAWNHELPER")
mobjinfo[MT_EGGROBO_SPAWNHELPER] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_EGGROBO_SPAWNHELPER,
	height = 1,
	radius = 1,	-- doesn't matter
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_RUNSPAWNFUNC,
}

-- make an eggrobo "descend"
function A_EggRoboSpawnHelper(mo)
	if not mo or not mo.valid return end
	local t = mo.target	-- < this is our eggrobo
	if not t or not t.valid return end	-- no target

	if mo.extravalue1
		t.flags2 = $|MF2_DONTDRAW
		mo.extravalue1 = $-1
		if not mo.extravalue1
			t.flags2 = $ & ~MF2_DONTDRAW
		end
	end

	if mo.extravalue2
		mo.extravalue2 = $-1
		-- update our target:
		t.angle = mo.angle
		t.z = mo.z
		t.threshold = mo.z
		return
	end

	mo.momz = (mo.threshold-mo.z)/4
	-- update our target:
	t.angle = mo.angle
	t.z = mo.z
	t.threshold = mo.z

	if not mo.momz and not mo.extravalue1
		t.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT)
		P_RemoveMobj(mo)
		return
	end
end

states[S_EGGROBO_SPAWNHELPER] = {SPR_NULL, A, 1, A_EggRoboSpawnHelper, 0, 0, S_EGGROBO_SPAWNHELPER}

function A_SilvCopyState(actor)	-- copy a mobj's spawnstate so that Silver can throw objects that overwrite movement (like buzzes)
	local tpe = actor.silv_desperatemeasure or actor.type
	actor.sprite = states[mobjinfo[tpe].spawnstate].sprite
	actor.frame = states[mobjinfo[tpe].spawnstate].frame
end
states[S_SILVTHROW] = {SPR_NULL, A, 1, A_SilvCopyState , 0, 0, S_SILVTHROW}

-- SPIN TRAIL ITEM:

freeslot("MT_SILVERTRAIL", "SPR_STHK", "S_SILVERTRAIL1", "S_SILVERTRAIL2")

function A_TrailColor(actor)
	local t = actor.target
	if not t or not t.valid or not t.player or not t.player.valid
		actor.color = SKINCOLOR_AQUA
	return end
	actor.color = silv_auracolor(t.player)
end

mobjinfo[MT_SILVERTRAIL] = {
	doomednum = -1,
	spawnstate = S_SILVERTRAIL1,
	height = 32*FRACUNIT,
	radius = 16*FRACUNIT,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_RUNSPAWNFUNC
}
states[S_SILVERTRAIL1] = {SPR_NULL, 0, 1, nil, 0, 0, S_SILVERTRAIL2}
states[S_SILVERTRAIL2] = {SPR_STHK, FF_TRANS70|FF_FULLBRIGHT, 16, A_TrailColor, 0, 0, S_NULL}

-- IDLE ITEMS
freeslot("MT_SILV_IDLEHOLD", "S_SILV_IDLEHOLD")
mobjinfo[MT_SILV_IDLEHOLD] = {
	doomednum = -1,
	spawnhealth = 1000,
	spawnstate = S_SILV_IDLEHOLD,
	radius = 16<<FRACBITS,
	height = 32<<FRACBITS,	-- doesn't matter
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOGRAVITY
}
states[S_SILV_IDLEHOLD] = {SPR_NULL, 0, -1, nil, 0, 0, S_SILV_IDLEHOLD}	-- dummy state


-- CBW BATTLE

-- spr2 for guard frame
freeslot("SPR2_GARD", "S_PLAY_SILVGUARD")
states[S_PLAY_SILVGUARD] = {SPR_PLAY, SPR2_GARD, 2, nil, 0, 0, S_PLAY_SILVGUARD}


-- fuck this game....
freeslot("S_LASER_FLAGSET")
function A_silv_LaserBlockmap(mo)
	mo.flags = $ & ~MF_NOBLOCKMAP
end
states[S_LASER_FLAGSET] = {SPR_MISL, FF_FULLBRIGHT, 1, A_silv_LaserBlockmap, 0, 0, S_NULL}
states[S_LASER].tics = 1
states[S_LASER].nextstate = S_LASER_FLAGSET

-- FUNCTIONS

-- silv_blockingWall:
-- wall busting
local function blockbusters(mo ,bustsec)
	for rover in bustsec.ffloors() -- search through FOFs in sector
		if not (rover.flags & FF_EXISTS) continue end -- FOF does not "exist" in sector!
		if not (rover.flags & FF_BUSTUP) continue end -- FOF is not bustable, ignore it

		if mo.z+mo.momz > rover.topheight -- too high
			continue
		end
		if mo.z + mo.momz+mo.height < rover.bottomheight -- too low
			continue
		end

		EV_CrumbleChain(bustsec, rover) -- DESTROY IT
		return true
	end
end

-- mo will break bustable blocks in its path
rawset(_G, "silv_FOFBuster", function(mo)
	local secs = {}

	secs[1] = R_PointInSubsector(mo.x, mo.y).sector
	secs[2] = R_PointInSubsector(mo.x+(mo.momx/2), mo.y + (mo.momy/2)).sector
	secs[3] = R_PointInSubsector(mo.x+(mo.momx), mo.y + (mo.momy)).sector
	secs[4] = R_PointInSubsector(mo.x+(mo.momx*2), mo.y + (mo.momy*2)).sector
	for i = 1, #secs
		local sec = secs[i]
		if blockbusters(mo, sec)
			return true	-- busted sector
		end
	end
end)

--	returns true if mobj is hitting a wall fast enough
local function PIT_blockLine(mo, l)
	if mo.flags & (MF_BOSS) and l.flags & ML_BLOCKMONSTERS
		return true
	end
end

rawset(_G, "silv_blockingWall", function(mobj, autothrust, wallbust)

	if wallbust and silv_FOFBuster(mobj) return end	-- no need to proceed past that point

	mobj.tester = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GARGOYLE) -- Has the best chance of not getting cleared on spawn
	local tester = mobj.tester
	tester.flags = MF_NOGRAVITY|MF_NOCLIPTHING|(mobj.flags & MF_BOSS) -- Make sure it won't move or block things
	tester.state = S_INVISIBLE -- make sure it fucks off afterwards
	tester.tics = 1

    tester.radius = mobj.radius
    tester.height = mobj.height
	-- special case...
	if mobj.type == MT_PSYCHOCUT
	and mobj.target and mobj.target.valid
		tester.radius = mobj.target.radius
		tester.height = mobj.target.height
	end
	if autothrust	-- this is for the psycho boost.
		P_InstaThrust(tester, mobj.angle, 8*mobj.scale)	-- little test
	else
		local angle = R_PointToAngle2(mobj.x, mobj.y, mobj.x+mobj.momx, mobj.y+mobj.momy)
		tester.angle = angle

		local maxdist = FixedHypot(mobj.momx, mobj.momy)
		P_InstaThrust(tester, angle, maxdist) -- Misuse P_InstaThrust to easily get the distance to move
	end

	local move = P_TryMove(tester, tester.momx+mobj.x, tester.momy+mobj.y, true)
	if not move return true end	-- couldn't move -> collide
	-- if nothing happened;

	tester.radius = $*2
	if not searchBlockmap("lines", PIT_blockLine, tester)
		return true
	end
	tester.radius = $/2
end)

-- CUT
freeslot("MT_PSYCHOCUT", "SPR_PSCT", "sfx_pscut")
freeslot("S_PSYCUT", "S_PSYCUT2")
mobjinfo[MT_PSYCHOCUT] = {
	-1,
	S_PSYCUT,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	32 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPHEIGHT|MF_NOCLIP,
	S_NULL
}
mobjinfo[MT_PSYCHOCUT].speed = FRACUNIT*45
mobjinfo[MT_PSYCHOCUT].painchance = 192*FRACUNIT

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local c = mo.colours
		if (c and c[2])
			mo.color = leveltime%4 >= 2 and c[2] or c[1]
		end
		
		if leveltime%5 == 0
			S_StartSound(mo, sfx_s3kbfs)
		end
		
	end
end, MT_PSYCHOCUT)

function A_PsycutWallcheck(mo)
	if mo and mo.valid
		local c = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSYCHOCUT)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.x+mo.momx, mo.y+mo.momy)
		c.state = S_INVISIBLE
		c.weapon = mo.weapon
		c.tics = 1
		c.height = mo.height
		c.radius = mo.radius
		c.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
		c.target = mo.target
		if leveltime%2
			local g = P_SpawnGhostMobj(mo)
			g.colorized = true
			g.tics = 4
		end

		if mo.weapon == WEP_GRENADE
			mo.momx = FixedMul(64500, $)
			mo.momy = FixedMul(64500, $)
			mo.momz = FixedMul(64500, $)

			if FixedHypot(mo.momx, mo.momy) < FRACUNIT*3
			and mo.momz < FRACUNIT*2
				mo.flags = MF_MISSILE|MF_NOGRAVITY
				A_RingExplode(mo)
				local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				a.state = S_INVISIBLE
				a.tics = TICRATE
				S_StartSound(a, sfx_pop)
				P_RemoveMobj(mo)
				return
			end
		end

		if silv_blockingWall(mo) and not (mo.flags & MF_BOUNCE)
			if mo and mo.explode
				mo.flags = MF_MISSILE|MF_NOGRAVITY
				A_RingExplode(mo)
				local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				a.state = S_INVISIBLE
				a.tics = TICRATE
				S_StartSound(a, sfx_pop)
			end
			P_RemoveMobj(mo)
		end
	end
end

states[S_PSYCUT] = {SPR_PSCT, A|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT}
states[S_PSYCUT2] = {SPR_PSCT, B|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT2}

-- returns true if we're in battlemod
rawset(_G, "silv_battleGT", function()
	local b = CBW_Battle
	return b and b.BattleGametype

	/*for k, v in pairs(b.Gametypes.TeamScoreType)	-- whatever works
		if gametype == k
			return true
		end
	end

	-- yes this function is fucking stupid.
	return false*/
end)

-- works with battlemod's diamond in the rough too i guess
rawset(_G, "silv_gotFlag", function(p)
	return p.gotflag or p.gotcrystal
end)

rawset(_G, "friendlyPlayer", function(p1, p2)						-- check 2 players. Returns true if the player is friendly, false else.

	local rules = gametyperules

	if p1 and p2 and p1.valid and p2.valid

	-- is our player a friend to the other?

		if rules & GTR_CAMPAIGN		-- Are we on coop?
		or gametype == GT_RACE		-- Race alone will count because else it's REALLY unfair.
		--and not cv_psynarchy.value

		or rules & GTR_TEAMS
		and p1.ctfteam == p2.ctfteam						-- Are we on a team gametype with both players on the same team?
		--and not cv_psynarchy.value

		or rules & GTR_TAG
		and ((p1.pflags & PF_TAGIT and p2.pflags & PF_TAGIT) or (not (p1.pflags & PF_TAGIT) and (not (p2.pflags & PF_TAGIT))))
		--and not cv_psynarchy.value
			--print("friends")
			return true								-- Then both players are friends! =D
		else
			--print("not friends.")
			return false							-- Then they're enemies! >:)
		end
	end
end)

-- yes good idea lets push uint32 to int32, itll be ok they said
-- NO IT'S NOT FUCKING OK YOU ABSOLUTE DUMBASS
rawset(_G, "angtoint", function(a)
	if not a return 0 end
	a = $/ANG1
	if a < 0
		a = $+360
	end
	return a
end)

-- basic linear interpolation. Percent must be between 0 and FRACUNIT
rawset(_G, "silv_lerp", function(start, finish, percent)
	return start + FixedMul(finish-start, FRACUNIT-percent)
end)

-- this is fucking retarded,
-- 2.2.11 will give warnings if we use P_TeleportMove
-- but also P_MoveOrigin doesn't exist yet in 2.2.10

if P_MoveOrigin
	rawset(_G, "silv_tp", P_MoveOrigin)
else
	rawset(_G, "silv_tp", P_TeleportMove)
end

