-- Battle Mod script for Silver
-- jimita: "by using Lua you're already agreeing to bend over to other scripts overriding your code :wonderful:"

rawset(_G, "silv_battleModSpeedShit", function(p)
	if p.cbw_cutspeed and p.mo and not p.actionstate
		p.cbw_cutspeed = false
		p.normalspeed = skins[p.mo.skin].normalspeed
	end
end)

-- different guard frames for silver
local function silv_battleGuardFrame(p)
	-- unique guard frame:
	local mo = p.mo
	if type(p.guard) == "number"	-- In case some funny mods make this into a boolean or whatever... This is too much of a generic var name :V
	and abs(p.guard) == 1
	-- implicit: p.guard == -1 (guard end?)
		mo.state = S_PLAY_STND
		mo.sprite2 = SPR2_GARD
		mo.frame = A
	end
end

-- AngelPlayer: Battlemod support
-- Enables a Chaos Energy powered 'Howling' to better fight against enemies with more elaborate behaviours.

local function silv_spawnCut(p)
	local mo = p.mo
	local atk = P_SPMAngle(mo, MT_PSYCHOCUT, mo.angle, 0)
	if atk and atk.valid	-- walls exist
		atk.height = FRACUNIT*16
		if not atk or not atk.valid return end
		atk.radius = FRACUNIT*42
		if not atk or not atk.valid return end
		
		atk.color = silv_auracolor(p)
		-- thrust the projectile faster and scale it up depending on p.actiontime
		P_Thrust(atk, atk.angle, min(32*FRACUNIT, p.actiontime / 4 *mo.scale))
		local speed = FixedHypot(atk.momx, atk.momy)
		local xyangle = R_PointToAngle2(0, 0, atk.momx, atk.momy)
		
		atk.state = S_PSYCUT2
		if not atk or not atk.valid return end
		
		p.actiontime = min($, mo.silv_pusedelay)
		atk.scale = $+ FixedMul(mo.scale, (p.actiontime/TICRATE)*FRACUNIT)
		if not atk or not atk.valid return end
		
		CBW_Battle.InstaThrustZAim(atk, xyangle, 0, speed, 0)
	end
end

local battoru_set
rawset(_G, "silv_loadBattleMod", function()

	local b = CBW_Battle
	if not b then return end		-- Mod not loaded
	
	-- HACK ALERT, don't let silver grab eggrobos if battlemod is active
	if silv_battleGT()
		silv_TKextra[MT_EGGROBO1].nograb = true
	else
		silv_TKextra[MT_EGGROBO1].nograb = false
	end	
	
	if battoru_set then return end	-- Mod already loaded in

	b.SkinVars["silver"] = {

		flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
		weight = 100,
		shields = 1,
		
		func_priority_ext = 	function(p)
									if p.mo.silv_floatstate == 2
										local satk = min((p.speed/FRACUNIT) /24, 2)
										satk = max($, 1)
										CBW_Battle.SetPriority(p, 1, 0, "knuckles_glide", satk, 1, "Psycho Boost")
									end	
								end,
		
		-- i'm sure this function's prototype violates several human rights conventions including in countries with no human rights to begin with like the USA.
		func_collide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			
			local p = plr[n1]	-- okay but why would you do that. what good does it do you!??
			local pmo = p.mo
			
			if pmo.silv_floatstate == 2 and collisiontype > 1
				silv_stopFloat(p)
			end
			return false
		end,
		
		special =	function(mo, act)

						local p = mo.player

						p.actiontext = "Psycho Cut"
						p.actionrings = 5
						p.actionsuper = true	-- getting hurt doesn't cancel the action.
						
						if p.actionstate
							p.cbw_cutspeed = true
							p.normalspeed = skins[mo.skin].normalspeed / 3
						end	

						if P_PlayerInPain(p)
						or p.tumble and p.tumble > 1
						or not mo.health
						or (p.actionstate == 0 and p.silv_actionstate)
							-- cancel ability:
							if p.actionstate
								p.actionstate = 0
								p.actiontime = -1
								mo.color = p.skincolor
								mo.colorized = false
								S_StopSound(mo)
								--S_StartSound(mo, sfx_s3k85)
								S_StartSound(mo, sfx_s3ka6)
								b.ApplyCooldown(p, TICRATE*3)
								p.silv_actionstate = nil
								return
							end
						end	
						
						if act == 1	-- just pressed
						and not p.actionstate
						--and p.rings >= p.actionrings
							--S_StartSound(mo, sfx_s3k84)
							S_StartSound(mo, sfx_s3ka3)
							p.actionstate = 1
							p.actiontime = 0
							-- ready usedelay charge:
							mo.silv_pusedelay = TICRATE*2
							mo.silv_usedelay = 2	-- give it 2 frames so it doesn't get unset
							p.silv_actionstate = true
							
							b.PayRings(p)

							--sfx_s3ka8 for full charge
						elseif (act == 2 or p.actiontime < TICRATE/2)	-- held
						and p.actionstate == 1
							p.actiontime = $+1
							mo.silv_usedelay = min(mo.silv_pusedelay or 0, p.actiontime or 0)

							if (leveltime%2)
								local o = P_SpawnMobjFromMobj(mo, P_RandomRange(-128, 128)*mo.scale, P_RandomRange(-128, 128)*mo.scale, P_RandomRange(32, 128)*mo.scale*P_MobjFlip(mo), MT_THOK)
								o.momx = (mo.x - o.x)/6 + mo.momx
								o.momy = (mo.y - o.y)/6 + mo.momy
								o.momz = ((mo.z + mo.height/2) - o.z)/6 + mo.momz
								o.scale = mo.scale/4
								o.tics = 7
								o.color = silv_auracolor(p)
								o.frame = A
							end

							local chargetime = max(4, TICRATE*2 - p.actiontime)
							if (leveltime % chargetime) < 2
								mo.color = silv_auracolor(p)
								mo.colorized = true
							else
								mo.color = p.skincolor
								mo.colorized = false
							end

							if p.actiontime == TICRATE*2
								S_StartSound(mo, sfx_s3ka8)
								local boost = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_THOK)
								boost.angle = mo.angle + ANG1*90
								boost.scale = $/2
								boost.state = S_HOWL1
								boost.color = p.powers[pw_super] and SKINCOLOR_GOLD or silv_auracolor(p)
								boost.destscale = mo.scale*99
								boost.scalespeed = mo.scale/6

							elseif p.actiontime > TICRATE*2
								silv_spawnAura(p)
								
								if leveltime % 5 == 0
									S_StartSound(mo, sfx_s3k5c)
								end
							end

						elseif act == 0	-- let go
						and p.actionstate == 1
							
							S_StopSound(mo)
							if p.actionstate
								-- spawn the psyshock:
								silv_spawnCut(p)
								local cooldown = TICRATE*4 + p.actiontime
								b.ApplyCooldown(p, cooldown)
								S_StartSound(mo, sfx_pscut)
								p.silv_actionstate = nil
							end

							mo.color = p.skincolor
							mo.colorized = false
							p.actiontime = -1
							p.actionstate = 0
							-- set the real use delay:
							silv_setUseDelay(mo, TICRATE*3/4)
						end
						
						if mo.silv_floatstate == 2
							p.canguard = false
						end	
						
						/*p.actiontext = "Ring Conversion"
						p.actionrings = 5
						p.actionsuper = true	-- getting hurt doesn't cancel the action.
						
						if mo.silv_energy >= SILVER_MAX_ENERGY
							p.actiontext = "\x86".."Energy already full"
						end
						
						if not p.actionstate and act == 1
							
							if mo.silv_energy >= SILVER_MAX_ENERGY
								return
							end	
							
							p.actionstate = 1
							p.actiontime = 1
							mo.silv_energy = min(SILVER_MAX_ENERGY, $+30)
							b.PayRings(p)
						end
						
						if p.actionstate == 1
							p.actiontime = $+1
							p.actiontext = "Hold to keep converting"
							
							if p.actiontime%3 == 0
							and p.rings
								p.rings = $ - 1
								mo.silv_energy = min(SILVER_MAX_ENERGY, $+10)
							end
							
							if not p.rings
							or (not (p.cmd.buttons & BT_ATTACK) and p.actiontime > TICRATE)
							or P_PlayerInPain(p)
							or p.tumble and p.tumble > 1
							or mo.silv_energy >= SILVER_MAX_ENERGY
								p.actiontime = 0
								p.actionstate = 0
								b.ApplyCooldown(p, TICRATE*5)
							end
						end*/

					end,

	}
	
	-- tkextra stuff...
	--mobjinfo[MT_SONICBOOM].flags = $ & ~MF_NOBLOCKMAP	-- stop putting that shit on your missiles!!!!!
	silv_TKextra[MT_SONICBOOM] = {
		nograb = false,
		noroll = true,
		
		resetf =	function(mo)
						P_RemoveMobj(mo)
					end,
		
		grabf =		function(mo)
						mo.silv_readysetfuse = true
					end,
		
		throwf =	function(mo)
						-- hack because throwf runs continuously
						if mo.silv_readysetfuse
							mo.fuse = TICRATE*5/2
							mo.silv_readysetfuse = nil
						end
					end,	
		
	}
	
	-- tails doll
	silv_TKextra[MT_SPARRINGDUMMY] = {
		nograb = true,
		noaim = false,
	}
	
	battoru_set = true
	print("\x82".."Silver BattleMod librairies succesfully loaded")
end)

addHook("PostThinkFrame", function()
	for p in players.iterate
		if p and p.mo and p.mo.valid and p.mo.skin == "silver"
			silv_battleGuardFrame(p)
		end
	end	
end)