-- In case you want to ever use Silver as a bot...
-- ...why would you?

local function seekEnemy(bot, allowboss)
	local ogangle = bot.mo.angle
	local mo = bot.mo
	allowboss = $ or 0

	--local tbl = silv_getTKtable()
	local tbl = mo.silv_dump or {}	-- not clearing this table after each frame was useful after all!
	if not tbl or not #tbl return false end
	for k,v in ipairs(tbl)
		mo.angle = ogangle
		if v == mo continue end
		if v.silv_grabbed continue end
		if v.type == MT_PLAYER
			if allowboss continue end
			if not (v.player) continue end
			if not (v.player.cmd.buttons & BT_TOSSFLAG) continue end
		end


		if v.flags & MF_MONITOR continue end
		if not (allowboss) and silv_getExtra(v, "nograb") continue end
		if (allowboss) and silv_getExtra(v, "noaim") continue end
		if not (allowboss) and v.flags & MF_BOSS continue end
		if not #mo.silv_telekinesis and not ((v.flags & (MF_ENEMY|MF_MISSILE)) or v.type == MT_PLAYER) continue end
		if #mo.silv_telekinesis and not (v.flags & MF_SHOOTABLE) and not (v.flags & (MF_ENEMY|MF_BOSS)) continue end

		mo.angle = R_PointToAngle2(mo.x, mo.y, v.x, v.y)
		if not ((R_PointToDist2(mo.x, mo.y, v.x, v.y) <= 512*mo.scale and P_CheckSight(mo, v)) or (v.flags & MF_BOSS and P_CheckSight(mo, v))) continue end

		mo.target = v
		mo.tracer = v	-- object is close, try
		mo.angle = R_PointToAngle2(mo.x, mo.y, v.x, v.y)	-- aim horizontally...
		bot.aiming = R_PointToAngle2(0, mo.z, R_PointToDist2(mo.x, mo.y, v.x, v.y), v.z)	-- aim vertically
		return true
	end
	return false
end


addHook("BotTiccmd", function(p, cmd)
	if p.mo and p.charability == 69
		local mo = p.mo
		local previoustgt = mo.target
		local master = players[0].mo	-- I mean we don't really have a choice
		local i

		if not master return end
		if not mo.silv_telekinesis return end	-- make sure every variable was initialized first...
		-- this is notably a problem with vl_botskin

		cmd.buttons = $ & ~BT_USE	-- don't match master's bt_use state

		-- indiactor bubble thing:
		if not mo.silv_botbubble or not mo.silv_botbubble.valid
			mo.silv_botbubble = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
			mo.silv_botbubble.target = mo
			mo.silv_botbubble.flags2 = $|MF2_DONTDRAW
			mo.silv_botbubble.state = S_FLIGHTINDICATOR
			mo.silv_botbubble.movecount = 0
		else

			-- movecount 0: don't draw
			if mo.silv_botbubble.movecount == 0
				mo.silv_botbubble.flags2 = $|MF2_DONTDRAW
			else
				mo.silv_botbubble.flags2 = $ & ~MF2_DONTDRAW
			end

			-- movecount 1: S_FLIGHTINDICATOR
			if mo.silv_botbubble.movecount == 1 and mo.silv_botbubble.state ~= S_FLIGHTINDICATOR
				mo.silv_botbubble.state = S_FLIGHTINDICATOR

			-- movecount 2: low energy...
			elseif mo.silv_botbubble.movecount == 2 and mo.silv_botbubble.state ~= S_SILV_TIREDINDICATOR
				mo.silv_botbubble.state = S_SILV_TIREDINDICATOR

			-- movecount 3: warning!
			elseif mo.silv_botbubble.movecount == 3 and mo.silv_botbubble.state ~= S_SILV_WARNINGINDICATOR
				mo.silv_botbubble.state = S_SILV_WARNINGINDICATOR
			end
		end
		mo.silv_botbubble.movecount = 0	-- don't draw by default

		-- okay real quick, check if we didn't grab master
		-- if we did, stop moving
		i = #mo.silv_telekinesis
		while i
			if mo.silv_telekinesis[i] == master
				-- match angle and aiming.
				cmd.forwardmove = 0
				cmd.sidemove = 0
				cmd.angleturn = 0
				mo.angle = master.angle
				cmd.aiming = master.player.aiming >> 16
				p.aiming = master.player.aiming
				cmd.buttons = (master.player.cmd.buttons & BT_USE)	-- allow master to throw themselves

				if master.player.cmd.buttons & BT_TOSSFLAG
					mo.silv_botnotk = true
				end

				-- spawn a general indicator on where the fuck we're headed?

				if leveltime%4 == 0
					local v = P_SpawnMobjFromMobj(master, 0, 0, 0, MT_THOK)
					v.flags2 = $ | master.flags2 & MF2_OBJECTFLIP
					v.eflags = $ | master.eflags & MFE_VERTICALFLIP
					v.flags = MF_MISSILE|MF_NOBLOCKMAP|MF_NOCLIPTHING
					v.color = silv_auracolor(p)

					local speed = 64
					v.momx = FixedMul(mo.scale, speed * FixedMul(cos(mo.angle), cos(p.aiming)))
					v.momy = FixedMul(mo.scale, speed * FixedMul(sin(mo.angle), cos(p.aiming)))
					v.momz = FixedMul(mo.scale, (speed) * sin(p.aiming))
				end
				mo.silv_botnomove = true
				return true	-- no need to continue, at all, override cmd behavior so that we don't move
			end
			i = $-1
		end

		mo.silv_botnomove = nil

		-- master let go off tf:
		if not (master.player.cmd.buttons & BT_TOSSFLAG)
		and P_IsObjectOnGround(master)
			mo.silv_botnotk = nil
		end

		-- silver float:
		if mo.silv_botfloatstate
			if mo.silv_botfloatstate == 1	-- initial jump
				cmd.buttons = $|BT_JUMP	-- hold jump button
				if (mo.eflags & MFE_VERTICALFLIP and mo.momz > 2*mo.scale)
				or (not (mo.eflags & MFE_VERTICALFLIP) and mo.momz < -2*mo.scale)	-- falling
					mo.silv_botfloatstate = 2
				end
			elseif mo.silv_botfloatstate == 2	-- middle point, we let go off jump for 1 frame and will start holding it next frame.
				mo.silv_botfloatstate = 3	-- I know this looks silly
			elseif mo.silv_botfloatstate > 3 and mo.silv_floatstate ~= 1		-- floatstae 1 is normal float.
				-- if we aren't floating anymore, stop this shit!
				mo.silv_botfloatstate = 0
				mo.silv_botwasholding = nil
				p.jumpfactor = skins[mo.skin].jumpfactor

			elseif mo.silv_botfloatstate > 2	-- we can now start floating, from there on out we hold jump and mimic the movement controls of the player holding onto us
				cmd.buttons = $|BT_JUMP
				mo.silv_botfloatstate = 4

				-- check if master has latched onto us
				for p2 in players.iterate do
					if not p2 or not p2.mo or not p2.mo.valid or p2.mo ~= master continue end
					-- make sure master is holding onto us
					if p2.mo.tracer == mo
						-- now mimic the movements
						cmd.forwardmove = p2.cmd.forwardmove
						cmd.sidemove = p2.cmd.sidemove
						mo.angle = master.angle
						mo.silv_botwasholding = true	-- we WERE holding p

						if mo.silv_energy < SILVER_MAX_ENERGY/5
							mo.silv_botbubble.movecount = 3	-- warning !
						end

					elseif mo.silv_botwasholding	-- they let go of us?
						cmd.buttons = $ & ~BT_JUMP
						mo.silv_botfloatstate = 0	-- just let go
						mo.silv_botwasholding = nil
					end
				end
			end
			return true	-- override behavior
		end


		if mo.silv_energy ~= nil and (mo.silv_energy > SILVER_MAX_ENERGY/5 or #mo.silv_telekinesis)

			if not #mo.silv_telekinesis

				if not mo.silv_botfloatstate
					local player = master.player

					if P_IsObjectOnGround(mo)
					and P_AproxDistance(mo.z-master.z,P_AproxDistance(mo.x-master.x,mo.y-master.y)) <= mo.radius*2	-- standing close
					and R_PointToDist2(0, 0, mo.momx, mo.momy) < 5*mo.scale
						-- make bubble appear:
						mo.silv_botbubble.movecount = 1

						if player.cmd.buttons & BT_JUMP and player.pflags & PF_JUMPED	-- madlad actually did it
							p.jumpfactor = player.jumpfactor*95/100
							cmd.buttons = $|BT_JUMP
							mo.silv_botfloatstate = 1	-- jumping
							return true	-- override behavior
						end
					end
				end

				if seekEnemy(p)				-- we have enemies in range woo.
				and not mo.silv_botnotk
					if leveltime%2			-- yes.
						cmd.buttons = $|BT_USE	-- press spin
					end
				end
			else
				if seekEnemy(p, true)			-- we have enemies in range woo.
				or master.player.cmd.buttons & BT_TOSSFLAG	-- foh
					if not mo.silv_delay			-- no need to use if we're on cool down lol
					and leveltime%2
						if mo.target and mo.target.valid
							mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)	-- aim horizontally...
							p.aiming = R_PointToAngle2(0, mo.z, R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y), mo.target.z)	-- aim vertically
						end
						cmd.buttons = $|BT_USE		-- press spin
					end
				end
			end
		elseif P_IsObjectOnGround(mo)
			mo.silv_botbubble.movecount = 2	-- tired
		end
	end
end)