-- extra lump for silver's telekinesis:
-- includes special enemy behavior

-- TKextra: Used for extra object properties w/ Telekinesis:
/*
	[MT_ITEM] = {
					nograb 		(boolean)	Sets whether the enemy can be GRABBED
					noaim		(boolean)	Sets whether the enemy can be AIMED AT
					noroll		(boolean)	Sets whether the enemy should be able to have rollangle effects or not
					killonwall	(boolean)	Instantly kills the mobj when thrown on a wall regardless of hitpoints.
					killonfloor	(boolean)	Instantly kills the mobj when it hits the floor
					nodamage	(boolean)	doesn't get damaged by being thrown on a wall or at an enemy

					boostbump	(boolean)	if true, silver's boost will bump off the enemy if it deals damage. Forcefully applied to non-monitor solid objects
					bossdamage 	(boolean)	if true, silver can't physically damage the object by jumping or using psychoboost. Used for vanilla bosses
					msondamage	(boolean)	special case used for metal sonic, but can be used for misc purposes

					grabf(mo)	(function)	Runs while the object is grabbed
					resetf(mo)	(function)	Runs ONCE when the enemy is reset after being let go of
					shieldf(mo)	(function)	Runs ONCE when the shield is grabbed
					boostcf(mo)	(function)	Runs ONCE when mo is collided with by the Psycho Boost, before boostbump is applied.
					shield		(constant)	MT_ constant of the tracer type expected to be the mobj's shield. The shield must be grabbed and unlinked before the object can be grabbed.
				}
*/


rawset(_G, "silv_TKextra", {})

silv_TKextra = {

	[MT_PLAYER] =		{
							noroll = true,
						},

	[MT_FBOMB]		=	{	-- fuck this object.

							noaim = true,	-- bruh

							grabf = function(mo)
										mo.flags = MF_RUNSPAWNFUNC	-- fuck you
									end,

							throwf = function(mo)
										mo.flags = MF_RUNSPAWNFUNC	-- fuck you too
									end,

							resetf = function(mo)

										local realbomb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FBOMB)
										realbomb.target = mo
										realbomb.scale = mo.scale
										P_KillMobj(realbomb)	-- fuck you too too

										P_RemoveMobj(mo)		-- fuck you AGAIN
									end,
						},

	[MT_FIREBALL]	=	{	-- oh boy, not again...
							noaim = true,
							grabf = function(mo, pmo)
										mo.silv_desperatemeasure = $ or mo.type
										mo.type = MT_ROCKET	-- fuck your mobjthinker, asshole
										mo.target = nil
									end,
							resetf = function(mo)
										mo.silv_desperatemeasure = nil
									end,
						},

	[MT_SPINFIRE]	=	{	-- oh boy, not again...
							noaim = true,
							nograb = true,
						},

	[MT_CRUSHSTACEAN] = {
							shield = MT_CRUSHCLAW,
							shieldf = 	function(claw)
											local chain = claw.target
											while chain
												local newmobj = P_SpawnMobjFromMobj(chain, 0, 0, 0, MT_THOK)
												newmobj.sprite = chain.sprite
												newmobj.frame = chain.frame
												newmobj.tics = -1
												newmobj.flags = MF_NOBLOCKMAP
												newmobj.flags2 = chain.flags2 & MF2_OBJECTFLIP
												newmobj.eflags = chain.eflags & MFE_VERTICALFLIP
												newmobj.fuse = TICRATE*2
												local newobj = chain.target
												if not newobj
													S_StartSound(newmobj, sfx_pop)
												end
												P_RemoveMobj(chain) -- bye
												P_SetObjectMomZ(newmobj, P_RandomRange(2, 8)*FRACUNIT)
												P_InstaThrust(newmobj, P_RandomRange(0, 359)*ANG1, P_RandomRange(2, 8)*FRACUNIT)
												chain = newobj
											end
										end,
						},

	[MT_BANPYURA]	=	{
							shield = MT_BANPSPRING,
						},

	[MT_EGGGUARD] =		{
							killonwall = true,	-- weirdly enough, this is necessary.
							shield = MT_EGGSHIELD,
						},
	[MT_EGGSHIELD] =	{
							nograb = true,
							noaim = true,
							boostbump = true,
							boostcf =	function(mo, pmo)

											S_StartSound(mo, sfx_wbreak)
											P_KillMobj(mo, pmo, pmo)
											if mo and mo.valid and mo.target and mo.target.valid
												mo.target.momx = pmo.momx	-- transfer momentums
												mo.target.momy = pmo.momy
												mo.tics = $+TICRATE
											end
										end,
						},

	[MT_PTERABYTE]	=	{
							grabf = function(mo, pmo)	-- save tracer / kill target and kill extravalue1 so that this guy stops behaving weirdly when grabbed.
										mo.target = nil
										mo.extravalue1 = 1	-- fake attack on player
										mo.movefactor = 5	-- but never let its movefactor decrement!
										mo.extravalue2 = 0	-- make sure this never increments
									end,
							resetf = function(mo)
										mo.extravalue1 = 2	-- makes it go back home
									end,
						},

	[MT_PYREFLY] 	=	{
							grabf = function(mo, pmo)
										mo.target = nil	-- prevents it from moving
									end,
						},

	[MT_BUGGLE]		=	{
							grabf = function(mo, pmo)
										mo.silv_desperatemeasure = $ or mo.type
										mo.type = MT_BLUECRAWLA	-- fuck your mobjthinker, asshole
										mo.target = nil
									end,
							resetf = function(mo)
										mo.silv_desperatemeasure = nil
									end,
						},

	[MT_DRAGONBOMBER] =	{	-- uses P_InstaThrust, we can't grab it because of this. :V
							nograb = true,
						},

	[MT_UNIDUS]		=	{
							resetf = function(mo)
										mo.momz = 0
									end
						},

	[MT_CRAWLACOMMANDER] = 	{
								grabf = function(mo)
											mo.target = nil	-- can't lunge if no target
										end,
								throwf = function(mo)
											mo.target = nil	-- ditto
										end,
								boostcf = 	function(mo, pmo)
												mo.momx = pmo.momx
												mo.momy = pmo.momy	-- transfer momentums
											end,
						},

	[MT_FACESTABBER] =	{
							noroll = true,
							boostbump = true,
							boostcf = 	function(mo, pmo)
											mo.momx = pmo.momx
											mo.momy = pmo.momy	-- transfer momentums
										end,
						},

	[MT_GOOP]		=	{
							noaim = true,
							noroll = true,
						},

	[MT_SHOCKWAVE]	=	{
							nograb = true,
							noaim = true,
						},

	[MT_FAKEMOBILE]	=	{
							noaim = true,
							nograb = true,
						},

	[MT_SKIM]		=	{
							grabf = function(mo, pmo)
										mo.silv_desperatemeasure = $ or mo.type
										mo.type = MT_BLUECRAWLA	-- fuck your mobjthinker, asshole
										mo.target = nil
									end,
							resetf = function(mo)	-- lol fuck this guy
										local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
										t.state = S_XPLD_FLICKY
										S_StartSound(t, sfx_pop)
										P_RemoveMobj(mo)
									end,
						},
	[MT_EGGROBO1]	=	{
							noaim = true,
							noroll = true,
							nodamage = true,	-- can't be damaged
							grabf	=	function(mo, pmo)
											mo.state = mobjinfo[mo.type].deathstate
											mo.movecount = 10000	-- prevents z momentum. this object will die no matter what happens.

											mo.saveheight = $ or mo.height
											mo.height = mo.saveheight/8

											if mo.helper and mo.helper.valid	-- that's the spawn helper, very unlikely to happen
												P_RemoveMobj(mo.helper)
												mo.helper = nil
											end	-- shouldn't happen, but this edge case should be accounted for anyway
										end,
							resetf	=	function(mo)
											local newmobj = P_SpawnMobj(mo.cusval, mo.cvmem, mo.threshold+1024*FRACUNIT, MT_EGGROBO_SPAWNHELPER)
											newmobj.angle = mo.movedir
											newmobj.threshold = mo.threshold	-- keep track of this
											newmobj.extravalue2 = P_RandomRange(3, 8)*TICRATE	-- how long until respawn?
											newmobj.extravalue1 = newmobj.extravalue2	-- mf2_dontdraw hack

											newmobj.target = P_SpawnMobjFromMobj(newmobj, 0, 0, 0, MT_EGGROBO1)	-- your new friend.
											newmobj.target.angle = mo.movedir
											newmobj.target.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
											newmobj.target.helper = newmobj

											local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
											t.state = S_XPLD_FLICKY
											S_StartSound(t, sfx_pop)
											P_RemoveMobj(mo)
										end
						},

	[MT_GSNAPPER]	=	{
							noroll = true,
							noreset = true,	-- custom reset behavior instead
							resetf = 	function(mo)	-- remove limbs and set to a proper state
											local p = mo.tracer
											while p
												p.fuse = 1
												p = p.tracer
											end
											mo.state = S_SNAPPER_SPAWN2
											mo.flags = mo.info.flags
										end,

							grabf = function(mo, pmo)	-- move the snapper's limbs along, and give them an aura similar to the main body's
										local p = mo.tracer
										while p
											p.momx = mo.momx
											p.momy = mo.momy
											p.momz = mo.momz

											local an = R_PointToAngle(p.x, p.y) + ANGLE_180
											local x, y = p.x + cos(an), p.y + sin(an)
											local overlay = P_SpawnMobj(x, y, p.z, MT_THOK)
											if splitscreen
												silv_tp(overlay, p.x, p.y, p.z)
											end
											--overlay.state = ref.state
											if not overlay or not overlay.valid break end	-- oops
											overlay.fuse = 1
											overlay.tics = p.tics
											overlay.scale = p.scale
											overlay.angle = p.angle
											overlay.color = mo.silv_passcolor
											overlay.colorized = true

											overlay.eflags = $ | p.eflags & MFE_VERTICALFLIP
											overlay.flags2 = $ | p.flags2 & MF2_OBJECTFLIP
											local tr = (5*FRACUNIT + (2*sin(leveltime*ANG1*16)))/FRACUNIT
											overlay.sprite = p.sprite
											overlay.frame = (p.frame & FF_FRAMEMASK)|FF_FULLBRIGHT|(tr<<FF_TRANSSHIFT)

											p = p.tracer
										end
									end,

							throwf = function(mo, pmo)	-- move the snapper's limbs along and give them an after image
										local p = mo.tracer
										while p
											p.momx = mo.momx
											p.momy = mo.momy
											p.momz = mo.momz
											if leveltime%2
												local g = P_SpawnGhostMobj(p)
												g.color = mo.silv_passcolor_noselection
												g.colorized = true
												g.destscale = p.scale*3/2
											end
											p = p.tracer
										end
									end,
						},

	[MT_TNTBARREL]	=	{
							noaim = true,
							killonfloor = true,
						},

	[MT_EGGMOBILE] =	{
							nograb = true,
							bossdamage = true,
						},

	[MT_EGGMOBILE2]	=	{
							bossdamage = true,
							nograb = true,
						},

	[MT_EGGMOBILE3]	=	{
							bossdamage = true,
							nograb = true,
						},

	[MT_EGGMOBILE4]	=	{
							bossdamage = true,
							nograb = true,
						},

	[MT_CYBRAKDEMON] =	{
							bossdamage = true,
							nograb = true,
						},

	[MT_METALSONIC_BATTLE] =	{
										msondamage = true,	-- special case
										bossdamage = true,	-- still couple this
										noroll = true,
										noreset = true,	-- don't use regular reset. resetf will still run.
										grabf = function(mo)
													mo.frame = O

													if mo.reactiontime < TICRATE*3/2	-- about to break out...!

														local fac = max(4, mo.reactiontime/4)

														if leveltime % fac == 0
															S_StartSound(mo, sfx_s3k5c)
															local a = R_PointToAngle(mo.x, mo.y)
															local aura = P_SpawnMobjFromMobj(mo, -2*cos(a), -2*sin(a), 0, MT_THOK)
															aura.eflags = $ | (mo.eflags & MFE_VERTICALFLIP)
															aura.sprite = mo.sprite
															aura.frame = mo.frame & FF_FRAMEMASK | (FF_FULLBRIGHT)
															aura.scale = mo.scale
															aura.fuse = 4
															aura.color = SKINCOLOR_WHITE
															aura.angle = mo.angle
															aura.rollangle = mo.rollangle
															aura.colorized = true
														end
													end

													if not (mo.flags & MF_SHOOTABLE) and mo.silv_grabbed
														for k,v in ipairs(mo.silv_grab.mo.silv_telekinesis)
															if v == mo
																local clr = silv_auracolor(v.silv_grabbed)
																v.silv_grabbed = nil
																v.frame = states[v.info.spawnstate].frame

																local aura = P_SpawnMobjFromMobj(v, 0, 0, 0, MT_THOK)
																aura.eflags = $ | (v.eflags & MFE_VERTICALFLIP)
																aura.sprite = v.sprite
																aura.frame = v.frame & FF_FRAMEMASK | (FF_FULLBRIGHT | (8<<FF_TRANSSHIFT))
																aura.scale = v.scale
																aura.destscale = v.scale*5
																aura.scalespeed = v.scale/4
																aura.fuse = 8
																aura.color = clr
																aura.angle = v.angle
																aura.rollangle = v.rollangle
																aura.colorized = true

																S_StartSound(v, sfx_s3k5e)
																table.remove(mo.silv_grab.mo.silv_telekinesis, k)
															end
														end
													end
												end,
									throwf = 	function(mo)
													mo.state = mo.info.painstate
													mo.reactiontime = max(2, $+1)	-- prevents a weird bug where metal would sometimes disappear
													mo.frame = O
													mo.momz = 0
													mo.flags = $|MF_SHOOTABLE
												end,
									resetf =	function(mo)
													mo.frame = states[mo.info.spawnstate].frame
													mo.flags = mo.info.flags & ~MF_SHOOTABLE
												end

							},
	[MT_EGGMOBILE_FIRE]	=	{
								grabf = function(mo)
											mo.fuse = TICRATE*2
											mo.flags = $|MF_MISSILE
										end
							},

	[MT_DRAGONMINE]	=		{
								noaim = true,
							},

	[MT_MINUS] =			{
								noroll = true,
								grabf = 	function(mo, pmo)
												mo.rollangle = 0
											end,
								throwf =	function(mo)
												mo.sprite = SPR_MNUS
												mo.frame = A
											end,
							},

	[MT_POINTY] =			{

								throwf =	function(mo)
												-- move our tracers
												local ball = mo.tracer
												while ball
													ball.momx = mo.momx
													ball.momy = mo.momy
													ball.momz = mo.momz
													ball = ball.tracer
												end
											end,
							},

	[MT_FANG]	=			{
								bossdamage = true,
								nograb = true,	-- make absolutely sure
							},

	[MT_NAMECHECK] =		{	nograb = true,
								noaim = true,
							},

	[MT_EGGMOBILE_FIRE]	=	{	nograb = true,
								noaim = true,
							},

	[MT_LASER]			=	{	noaim = true,
								grabf = 	function(mo)
												mo.tics = -1	-- inftics
											end,
							},

	[MT_SPIKE] 			=	{
								noaim = true,
								nograb = true,
								boostcf = 	function(mo, pmo, pmo)
												P_KillMobj(mo, pmo, pmo)
											end,
							},
	[MT_WALLSPIKE]		=	{
								noaim = true,
								nograb = true,
								boostcf =	function(mo, pmo, pmo)
												P_KillMobj(mo, pmo, pmo)
											end,
							},
}

-- finally, golden monitors should be aimable but not grabbable. That's right, you'll have to get creative if you want them!
for i = 1, #mobjinfo-1
	if mobjinfo[i] and mobjinfo[i].flags & (MF_MONITOR|MF_GRENADEBOUNCE) == MF_MONITOR|MF_GRENADEBOUNCE	-- that's a weird ass flag combination tbh

		silv_TKextra[i] = {
			nograb = true,
			noaim = false,
			boostbump = true,
			boostcf = 	function(mo, pmo)
							P_DamageMobj(mo, pmo, pmo)
						end
		}
	elseif mobjinfo[i] and mobjinfo[i].flags & MF_MONITOR and not (mobjinfo[i].flags & MF_GRENADEBOUNCE)	-- normal monitors
		silv_TKextra[i] = {
			boostcf = 	function(mo, pmo)
							P_KillMobj(mo, pmo, pmo)
						end
		}

		if i == MT_1UP_BOX	-- 1ups shouldn't roll because of how their icon behaves
			silv_TKextra[i].noroll = true
		end
	end
end