-- Literally the bane of my existence

rawset(_G, "MAX_TELEKINESIS_RANGE", FRACUNIT*768)
rawset(_G, "MAX_TELEKINESIS_HOLD", 4)

--local respawnitemqueue_debug = true
local silv_respawnqueue = {}

rawset(_G, "silv_addToRespawnQueue", function(mo, time)
	for i = 1, #silv_respawnqueue
		if silv_respawnqueue[i][1] == mo
			--print(tostring(mo).." already in")
			return
		end	-- already in
	end
	
	if not mo.spawnpoint or not mo.spawnpoint.valid
		--print(tostring(mo).." no spawnpoint")
		if not mo.silv_fakespawnpoint
			--print(tostring(mo).." no fake spawnpoint...")
			return
		end
	end	
	
	--print("added "..tostring(mo))
	silv_respawnqueue[#silv_respawnqueue+1] = {mo, time}
end)

-- respawn queue for monitors
rawset(_G, "silv_itemRespawnQueue", function()
	local i = #silv_respawnqueue
	while i
		local r = silv_respawnqueue[i]
		if r
		
			r[2] = $-1
			if not r[1] or not r[1].valid or r[1].silv_grabbed
				table.remove(silv_respawnqueue, i)
				i = $+1
				
			elseif r[2] == 1
				local mo = r[1]
				local x, y, z
				
				if mo.silv_fakespawnpoint
					x, y, z = mo.silv_fakespawnpoint[1], mo.silv_fakespawnpoint[2], mo.silv_fakespawnpoint[3]
					
				elseif mo.spawnpoint and mo.spawnpoint.valid
					x, y = mo.spawnpoint.x<<FRACBITS, mo.spawnpoint.y<<FRACBITS				
					local floorz = R_PointInSubsector(x, y).sector.floorheight
					local flip = 2
					z = floorz + (mo.spawnpoint.z<<FRACBITS)*(mo.spawnpoint.options & flip and -1 or 1)
				end
				
				silv_tp(mo, x, y, z)

				table.remove(silv_respawnqueue, i)
				i = $+1
			end
		end	
		i = $-1
	end
end)

addHook("MapLoad", do
	silv_respawnqueue = {}	-- flush
end)

addHook("NetVars", function(net)
	silv_respawnqueue = net(silv_respawnqueue)	-- net synch
end)

local camchase

rawset(_G, "silv_setUseDelay", function(mo, t)
	if tonumber(t) == nil return end
	mo.silv_pusedelay, mo.silv_usedelay = t, t
end)

rawset(_G, "silv_execExtra", function(mo, extra, arg1, arg2)
	if not mo or not mo.valid return end
	local t = mo.silv_desperatemeasure or mo.type
	if silv_TKextra[t] and silv_TKextra[t][extra]
		silv_TKextra[t][extra](arg1, arg2)
	end
end)

rawset(_G, "silv_getExtra", function(mo, extra)
	if not mo or not mo.valid return end
	local t = mo.silv_desperatemeasure or mo.type
	if silv_TKextra[t] and silv_TKextra[t][extra]
		return silv_TKextra[t][extra]
	end
end)

rawset(_G, "silv_resetObject", function(mo)		-- resets an object for further Telekinesis use
	if not mo or not mo.valid or not mo.health return end
	mo.silv_grabbed = nil
	mo.silv_target = nil
	mo.rollangle = 0	-- reset this
	if mo.silv_desperatemeasure
		mo.type = mo.silv_desperatemeasure
	end
	silv_execExtra(mo, "resetf", mo)			-- still run this in spite of noreset, can lead to custom reset behaviors
	if not mo or not mo.valid return end		-- anything could happen in resetf...
	if silv_getExtra(mo, "noreset") return end	-- you heard the man
	--mo.silv_grab = nil
	mo.state = mobjinfo[mo.type].spawnstate
	mo.flags = mobjinfo[mo.type].flags

	if mo.player	-- REEE
		local p = mo.player
		local skin = skins[mo.skin]
		p.normalspeed = skin.normalspeed
		p.jumpfactor = skin.jumpfactor
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_FALL
		end
		p.silv_grabbed = nil
	end

end)

freeslot("sfx_ovrchr")
local function silv_fillGauge(p, amount)
	if p and p.mo and p.mo.valid and not p.powers[pw_super]
		amount = $ or 1
		local mo = p.mo
		mo.silv_energy = min(SILVER_MAX_ENERGY, $+amount)
		/*if mo.silv_energy >= SILVER_MAX_ENERGY
			mo.silv_boostenergy = TICRATE*4
			mo.silv_energy = SILVER_MAX_ENERGY
			S_StartSound(nil, sfx_ovrchr, p)
		end*/
	end
end

local function tagGrab(p1, p2)
	if p1 and p2 and p1.valid and p2.valid
		if G_TagGametype()
		and (p1.pflags & PF_TAGIT and not (p2.pflags & PF_TAGIT) or (not (p1.pflags & PF_TAGIT)) and p2.pflags & PF_TAGIT)
			return false
		else
			return true
		end
	end
end

local function explodeTK(target)
	if not target or not target.valid return end
	for i=1,16
		local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_THOK)
		b.momx = P_RandomRange(-20, 20)*FRACUNIT
		b.momy = P_RandomRange(-20, 20)*FRACUNIT
		b.momz = P_RandomRange(-20, 20)*FRACUNIT
		b.frame = A|FF_FULLBRIGHT|TR_TRANS30
		b.color = (target.silv_grab and target.silv_grab.valid) and silv_auracolor(target.silv_grab) or SKINCOLOR_TEAL
		b.scale = FRACUNIT
		b.tics = $*2
		b.destscale = FRACUNIT/12
	end
end

-- keeps track of what was added, just in case
-- telekinesis table update function:
addHook("MobjSpawn", function(mo)
	silv_resetObject(mo)
end, MT_PLAYER)


local function telk_resetmonitor(mo)
	if mo.silv_x ~= nil
	and (netgame)
		-- spawn fake monitor...
		local faketv = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MONITOREXPLOSION)
		faketv.fuse = TICRATE*10
		faketv.flags = mo.flags
		faketv.flags2 = mo.flags
		faketv.eflags = mo.eflags
		local fakeicon = P_SpawnMobj(mo.x, mo.y, mo.z, mobjinfo[mo.type].damage)
		fakeicon.flags = mo.flags|MF_NOGRAVITY
		fakeicon.flags2 = mo.flags2
		fakeicon.eflags = mo.eflags
		P_SetObjectMomZ(fakeicon, FRACUNIT*4)
		silv_tp(mo, mo.silv_x, mo.silv_y, mo.silv_z)	-- go back!
	end
end

-- function for found objects within the blockmap
-- all found mobjs are put inside t. Remember that t is a pointer, numbskull
local function PIT_silverSearchThings(mo, v)

	local maxrange = mo.silv_maxrange
	local notv = mo.silv_notv
	local tcheck = mo.silv_tcheck
	local p = mo.player

	if v and v.valid and R_PointToDist2(v.x, v.y, tcheck.x, tcheck.y) < maxrange and v ~= mo
	and ((mobjinfo[v.type].flags & (MF_ENEMY|MF_BOSS|MF_MONITOR|MF_MISSILE) or v.type == MT_PLAYER) or silv_TKextra[v.type])
	and not (mo.silv_grab == v)	-- lolno
	and abs(mo.z - v.z) < maxrange
	and v.health	-- don't grab dead things
	and not (not notv and silv_getExtra(v, "nograb"))
	and not (notv and silv_getExtra(v, "noaim"))
	and not v.silv_grabbed	-- not already grabbed
	and (not (notv and v.flags & MF_MISSILE) or (silv_TKextra[v.type]))
	and not (p.bot and v.flags & MF_MONITOR)	-- bots cannot grab monitors
	and (not (not (notv) and v.flags & MF_BOSS) or (silv_TKextra[v.type] and v.flags & MF_SHOOTABLE))	-- only target bosses when we're throwing
	and not (v.floorz >= mo.ceilingz)
	and not (v.ceilingz <= mo.floorz)
	and not (v.flags & (MF_ENEMY|MF_BOSS) and not (v.flags & MF_SHOOTABLE or silv_getExtra(v, "shield")))
	and not (v.player and v.player.spectator)
	and not (v.player and friendlyPlayer(p, v.player) and not (v.player.cmd.buttons & BT_TOSSFLAG and not notv))
	and not (v.player and not (tagGrab(p, v.player)))
	and not (v.player and not friendlyPlayer(p, v.player) and (v.player.powers[pw_flashing] or v.player.powers[pw_invulnerability] or (not notv and silv_battleGT() and not v.player.tumble )))
	and not (v.flags & MF_MISSILE and v.target and v.target.valid and v.target.player and friendlyPlayer(p, v.target.player))	-- cannot grab friendly projectiles
	-- special cases
	and not (G_GametypeHasTeams() and (v.type == MT_RING_BLUEBOX and p.ctfteam ~= 2 or v.type == MT_RING_REDBOX and p.ctfteam ~= 1))
	and P_CheckSight(mo, v)	-- last check

		-- finally, check if the object we're aiming at isn't being aimed at by another one of our objects right now
		-- or if this isn't an object we've thrown
		local targetted
		for i = 1, #mo.silv_thrown
			local o = mo.silv_thrown[i]
			if o and o.valid
			and ((o.silv_target and o.silv_target.valid and o.silv_target == v or o.silv_grabbed and o.silv_grabbed.valid and o.silv_grabbed == p) or o == v)
				return	-- we already threw something at this thing! don't continue
			end
		end

		local tadd = v
		local tbackup = v
		-- if we found an enemy with a shield, then we must add the shield
		local s = silv_getExtra(v, "shield")
		if s
		and not notv
			tadd = v.tracer
			if tadd and tadd.valid
				tadd.silv_removeshield = tbackup.type
			else
				tadd = tbackup
			end
		end

		table.insert(mo.silv_dump, tadd)
	end
end

local function silv_sortObjects(p, n, notv)	-- return the 4 closest objects to us...

	local mo = p.mo
	if not mo return {} end
	local dump = {}
	local mindist = FixedMul(mo.scale, MAX_TELEKINESIS_RANGE) / FRACUNIT
	local removekey = 0
	local add

	--1: Spawn dummy object in front of us as a poor excuse of an hitbox
	local dist = mindist/2
	local x, y, z = mo.x + dist*cos(mo.angle), mo.y + dist*sin(mo.angle), mo.z
	local tcheck = P_SpawnMobj(x, y, z, MT_NULL)

	local maxrange = FixedMul(MAX_TELEKINESIS_RANGE/2, mo.scale)

	mo.silv_dump = {}
	mo.silv_notv = notv
	mo.silv_tcheck = tcheck
	mo.silv_maxrange = maxrange	-- temporary values we need to pass through the blockmap iterator
	searchBlockmap("objects", PIT_silverSearchThings, mo, tcheck.x - maxrange, tcheck.x + maxrange, tcheck.y - maxrange, tcheck.y + maxrange)
	dump = mo.silv_dump	-- oh god.

	if not #dump then return {} end

	if #dump < n then n = #dump end
	local ref = notv and p.mo or tcheck
	-- if grabbing, compare distance from the dummy object. Otherwise, distance from silver himself.

	mindist = 99999	-- we only have valid objects left here as far as i'm aware

	--4: scream in panic
	local enemies = {}
	repeat
		for i = 1, #dump do
			local v = dump[i]
			if not (v or v.valid) continue end
			local dist = R_PointToDist2(v.x, v.y, ref.x, ref.y) / FRACUNIT -- gross simplification
			if dist < mindist
				mindist = dist
				add = v
				removekey = i
			end
		end

		if add
			enemies[#enemies+1] = add
			table.remove(dump, removekey)
			mindist = 99999
			removekey = 0
			add = nil
		end
	until #enemies >= n

	mo.silv_dump = enemies	-- useful for silver bot
	return enemies
end

rawset(_G, "silv_droptelekinesis", function(p, i)
	local mo = p.mo
	if not mo return end
	if not mo.silv_telekinesis return end
	if not #mo.silv_telekinesis return end

	local k = #mo.silv_telekinesis
	while k
		if i and i ~= k
			k = $-1
			continue
		end
		local v = mo.silv_telekinesis[k]
		if v and v.valid
			if mobjinfo[v.type].flags & MF_MISSILE	-- kill missiles, else they're gonna stay here floating about for no reason lmao
				v.target = mo	-- make the missile belong to us so that if it's an explosion / grenade ring, it can hurt players and award us points
				v.flags = $|MF_MISSILE	-- give it back its flag
				P_KillMobj(v)
			else
				silv_resetObject(v)
				
				-- pop players up to avoid pit spikes
				if silv_battleGT()
				and v and v.valid
				and v.type == MT_PLAYER
					v.state = S_PLAY_FALL
					P_SetObjectMomZ(v, 8*FRACUNIT, false)
				end
			end
		end
		table.remove(mo.silv_telekinesis, k)
		k = $-1
	end
end)

-- push object
local function silv_push(p, obj)
	if not p.mo return end
	if not obj return end
	-- special case for players:
	if obj.type == MT_PLAYER
	and obj.player
		P_DoPlayerPain(obj.player)
	end
	local mo = p.mo
	local pushangle = R_PointToAngle2(mo.x, mo.y, obj.x, obj.y)
	local pushforce = FRACUNIT*48 - (R_PointToDist2(mo.x, mo.y, obj.x, obj.y) / 16)
	P_InstaThrust(obj, pushangle, pushforce)
	P_SetObjectMomZ(obj, FRACUNIT*5)
end

-- push nearby enemies / the ball. Only for thokker.
local function silv_thokkerpush(p)
	local mo = p.mo
	if not mo return end
	-- show radius
	for i = 1, 16
		local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		thok.color = silv_auracolor(p)
		thok.angle = $+ ((ANG1*45)/2)*(i-1)
		thok.tics = 10
		thok.scale = mo.scale
		thok.destscale = mo.scale/10
		thok.scalespeed = FRACUNIT/10
		P_InstaThrust(thok, thok.angle, 79*FRACUNIT)
	end
	S_StartSound(mo, sfx_s3k83)

	-- push players:
	for player in players.iterate do
		if player.mo and player.ctfteam ~= p.ctfteam and R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y) < mo.scale*768 and abs(player.mo.z - mo.z) < FRACUNIT*256
			silv_push(p, player.mo)
		end
	end

	-- push ball
	for obj in mobjs.iterate()
		if thokker and obj and obj.valid and obj == thokker.theball
		and R_PointToDist2(mo.x, mo.y, obj.x, obj.y) < mo.scale*768 and abs(obj.z - mo.z) < FRACUNIT*256
			silv_push(p, obj)
		end
	end
end

-- Snu, you better draw me some yuri for this..........
local function silv_handleTKselection(p)
	if not p return end
	local mo = p.mo

	if mo.silv_selection == nil
		mo.silv_selection = 0
		mo.silv_selectiontimer = 0
	end

	if not mo.silv_telekinesis or #mo.silv_telekinesis < 2
		mo.silv_selection = 0
	return end

	-- hacky timers we'll need, or something
	if p.cmd.buttons & BT_WEAPONNEXT
		mo.silv_nextt = mo.silv_nextt and $+1 or 1
	else
		mo.silv_nextt = 0
	end
	if p.cmd.buttons & BT_WEAPONPREV
		mo.silv_prevt = mo.silv_prevt and $+1 or 1
	else
		mo.silv_prevt = 0
	end

	if mo.silv_nextt == 1
		mo.silv_selection = $+1
		if mo.silv_selection > #mo.silv_telekinesis
			mo.silv_selection = 0
		end
		S_StartSound(mo, sfx_s23a, mo.player)
		mo.silv_selectiontimer = 0
	elseif mo.silv_prevt == 1
		mo.silv_selection = $-1
		if mo.silv_selection < 0
			mo.silv_selection = #mo.silv_telekinesis
		end
		S_StartSound(mo, sfx_s23a, mo.player)
		mo.silv_selectiontimer = 0
	end

	-- manage BT_WEAPONMASK
	if p.cmd.buttons & BT_WEAPONMASK
		mo.silv_maskt = mo.silv_maskt and $+1 or 1
	else
		mo.silv_maskt = 0
	end

	if mo.silv_maskt == 1
		mo.silv_selection = min(#mo.silv_telekinesis+1, (p.cmd.buttons & BT_WEAPONMASK))
		if mo.silv_selection > #mo.silv_telekinesis
			mo.silv_selection = 0	-- throw all
		end
		mo.silv_selectiontimer = 0
		S_StartSound(mo, sfx_s23a, mo.player)
	end

	-- selection issues, under or over max values for WHATEVER reason
	mo.silv_selection = min($, #mo.silv_telekinesis)
	mo.silv_selection = max(0, $)

	mo.silv_selectiontimer = $+1
end

-- debug
local hu_targets = {}

hud.add(function(v, p, c)
	if not silv_debug() return end
	for i = 1, #hu_targets
		if not hu_targets[i].valid continue end
		v.drawString(320, 0+(i-1)*10, hu_targets[i].type, V_SNAPTOTOP|V_SNAPTORIGHT, "right")
	end
end)

rawset(_G, "silv_handleTelekinesis", function(p)
	local mo = p.mo
	if not mo return end
	if p.charability ~= 69 return end

	if not mo.silv_telekinesis
		mo.silv_telekinesis = {}		-- objects we're holding	(up to 4)
		mo.silv_thrown = {}				-- all the shit we've thrown
	end

	-- Telekinesis selection
	silv_handleTKselection(p)
	
	if silv_gotFlag(p)
		mo.silv_hadflag = true
	elseif not (p.cmd.buttons & BT_TOSSFLAG)
		mo.silv_hadflag = nil
	end
	
	-- tossflag hold:
	if (p.cmd.buttons & BT_TOSSFLAG and not silv_gotFlag(p)and not mo.silv_hadflag) or p.cmd.buttons & BT_CUSTOM1
		mo.silv_tossflag = mo.silv_tossflag ~= nil and $+1 or 1
	else
		mo.silv_tossflag = 0
	end

	local targets = {}
	if mo.silv_telekinesis and #mo.silv_telekinesis
		targets = silv_sortObjects(p, #mo.silv_telekinesis, true)
	else
		if P_IsObjectOnGround(mo)
			targets = silv_sortObjects(p, MAX_TELEKINESIS_HOLD)	-- pick up to 4 objs
		end
	end

	if p == displayplayer
		hu_targets = {}
		for i = 1, #targets
			hu_targets[i] = targets[i]
		end
	end

	-- spawn target marks on objects:
	if not (mapheaderinfo[gamemap].thokkerball and gametype == GT_TEAMMATCH)
		for i = 1, #targets do
			if (mo.silv_energy < SILVER_MAX_ENERGY/4 and not #mo.silv_telekinesis)	-- that'd be for aiming
			or p.pflags & PF_SPINNING		-- don't display if you can't use telekinesis
			or p.actionstate				-- don't display if charging a cut in bmod.....
			or p.powers[pw_carry]
				break
			end

			local dum = P_SpawnMobjFromMobj(targets[i], 0, 0, 0, MT_NULL)
			dum.fuse = 5
			dum.tics = 5
			dum.height = targets[i].height
			dum.radius = targets[i].radius
			dum.eflags = targets[i].eflags & MFE_VERTICALFLIP
			dum.scale = targets[i].scale
			-- scale lockon down if this isn't the main throw target:
			if mo.silv_selection and i > 1
				dum.scale = max($/2, ($*(#targets- (i-1))) / #targets)
				dum.height = min($*2, ($*#targets)/(#targets- (i-1)))
			end
			--print(tostring(dum.scale*100 / FRACUNIT))
			P_SpawnLockOn(p, dum, S_LOCKON_SILV)
		end
	end

	-- use timer:
	mo.silv_useheld = $ or 0
	if p.cmd.buttons & BT_USE
		mo.silv_useheld = $+1
	else
		mo.silv_useheld = 0
	end
	
	mo.silv_matchplus_telekinesis = nil		-- this will probably go on unused lol
	if (mo.silv_useheld == 1)
	and not p.powers[pw_carry]
	and not mo.silv_usedelay
	and not (p.pflags & (PF_SPINNING|PF_STARTDASH))
	and not p.exiting
	and not (p.powers[pw_nocontrol])
	and not (silv_gotFlag(p) and not silv_battleGT())	-- allow telekinesis while holding the flag in battlemod only
	and not mo.silv_sliding
		if not mo.silv_firehold
		and not (mo.silv_floatstate and mo.silv_floatstate <= 2)
		and not P_PlayerInPain(p)

			-- we playing thokker???
			if mapheaderinfo[gamemap].thokkerball and gametype == GT_TEAMMATCH
				if mo.silv_energy >= SILVER_MAX_ENERGY/4
					silv_thokkerpush(p)
					silv_setUseDelay(mo, TICRATE*2)
					mo.silv_energy = $ - SILVER_MAX_ENERGY/4
				end
				return
			end

			if not #mo.silv_telekinesis		-- it's safe to assume that we're not holding anything and seek to remedy to the problem :P

				mo.silv_matchplus_telekinesis = true
				if P_IsObjectOnGround(mo)	-- I guess let's follow Speedwagon's suggestion...
				and mo.silv_energy > SILVER_MAX_ENERGY/4
				and not mo.silv_grabbed	-- cannot grab if being grabbed. This avoids weird Telekinesis trains
					if silv_meme()
						S_StartSound(mo, sfx_thrw1)
					end
					silv_setUseDelay(mo, TICRATE)
					mo.silv_telekinesis = targets
					if #targets
						mo.silv_energy = $ - SILVER_MAX_ENERGY/4	-- bye energy
					end

					-- show a radius?
					for i = 0, 15
						local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						thok.color = silv_auracolor(p)
						thok.angle = (mo.angle - 80*ANG1) + i*ANG1*10
						thok.tics = 10
						thok.scale = mo.scale
						thok.destscale = mo.scale/10
						thok.scalespeed = FRACUNIT/10
						P_InstaThrust(thok, thok.angle, 79*FRACUNIT)
					end

					S_StartSound(mo, sfx_s3k74)

					p.mo.silv_selection = 1
					if p.silv_throwall
						p.mo.silv_selection = 0	-- select all in that case
					end

					-- ready some stuff with our newly grabbed objects...
					for k,v in ipairs(mo.silv_telekinesis)
						v.silv_grabbed = p	-- make sure we won't get grabbed by anything else

						if v.silv_removeshield
							if silv_TKextra[v.silv_removeshield] and silv_TKextra[v.silv_removeshield]["shieldf"]
								silv_TKextra[v.silv_removeshield]["shieldf"](v)
							end
							local new = P_SpawnMobjFromMobj(v, 0, 0, 0, MT_THOK)
							new.angle = v.angle
							new.rollangle = v.rollangle
							new.flags = MF_NOGRAVITY
							new.sprite = v.sprite
							new.sprite2 = v.sprite2
							new.frame = v.frame
							new.tics = -1
							P_RemoveMobj(v)
							mo.silv_telekinesis[k] = new
							continue
						end

						v.flags = $|MF_SLIDEME	-- this helps
						v.flags = $ & ~MF_SOLID
						v.flags = $ & ~MF_SPECIAL
						v.flags = $ & ~MF_ENEMY	-- remove enemy flag to cross ML_BLOCMONSTERS lines
						if v.flags & MF_MONITOR
							
							-- fuck this game dude...
							v.silv_fakespawnpoint = $ or {v.x, v.y, v.z}
							
							v.flags = $ & ~MF_MONITOR
							v.flags = $ & ~MF_SHOOTABLE	-- don't destroy monitors
						end
						if v.flags & MF_MISSILE
							v.flags = $ & ~MF_MISSILE
							v.target = mo
							v.fuse = -1	-- stop item fuse
						end
						if v.player	-- oh no...
							if not friendlyPlayer(v.player, p)
							and not silv_battleGT()	-- no need to extend the cooldown in cbw battle.
								silv_setUseDelay(mo, TICRATE*2)	-- ringslinger balance????
							end
							P_ResetPlayer(v.player)
							v.player.normalspeed = 0; v.player.jumpfactor = 0; v.player.silv_grabbed = true	-- yes, you never know, the god damn map might be changed inbetween.
							v.player.pflags = $ & ~(PF_JUMPED|PF_GLIDING)
							v.player.glidetime = 0
							v.player.skidtime = 0
						end

						-- some cool random vars for visual effects
						v.silv_roll = P_RandomRange(-3, 3)*ANG1	-- rollangle
						v.silv_zoffs = P_RandomRange(1, TICRATE*2)	-- float offset

					end
				end
			else	-- we're throwing that shit away

				local memeseed = P_RandomRange(0, 2)	-- generate even if we're not in meme mode to prevent desynch
				if silv_meme()
					S_StartSound(mo, sfx_thrw2+memeseed)
				end

				silv_setUseDelay(mo, 5)
				mo.silv_throwcombo = 0
				S_StartSound(mo, sfx_pscut)
				if not #targets or mo.silv_botnomove
					local k = #mo.silv_telekinesis
					while k
						local v = mo.silv_telekinesis[k]
						-- SELECTION CHECK: Make sure we aim the to the closest object <3
						if mo.silv_selection and k > 1
							k = $-1
							continue
						end
						-- just throw them
						table.insert(mo.silv_thrown, v)
						if (v.flags & MF_ENEMY or v.info.flags & MF_ENEMY)
						and (v.flags & MF_NOGRAVITY or v.info.flags & MF_NOGRAVITY)
							v.state = S_SILVTHROW
						end
						v.flags = mobjinfo[v.type].flags & ~MF_ENEMY	-- let enemies cross ML_BLOCKMONSTERS lines
						v.silv_grabbed = nil				-- we aren't being grabbed anymore, meaning silvers can retaliate against one another :P
						local speed = 64
						local aiming = p.aiming
						
						if silv_battleGT()
							aiming = 0
						end	
						
						v.momx = FixedMul(mo.scale, speed * FixedMul(cos(mo.angle), cos(aiming)))
						v.momy = FixedMul(mo.scale, speed * FixedMul(sin(mo.angle), cos(aiming)))
						v.momz = FixedMul(mo.scale, (speed) * sin(aiming))
						table.remove(mo.silv_telekinesis, k)
						mo.silv_selectiontimer = 0
						k = $-1
					end
				else
					local k = #mo.silv_telekinesis
					while k
						local v = mo.silv_telekinesis[k]
						-- SELECTION CHECK
						if mo.silv_selection and k ~= mo.silv_selection
						or not v.valid
							k = $-1
							continue
						end
						-- set target
						local index = k
						if k > #targets then index = #targets end
						if (v.flags & MF_ENEMY or v.info.flags & MF_ENEMY)
						and (v.flags & MF_NOGRAVITY or v.info.flags & MF_NOGRAVITY)
							v.state = S_SILVTHROW
						end
						v.flags = mobjinfo[v.type].flags & ~MF_ENEMY	-- let enemies cross ML_BLOCKMONSTERS lines
						v.silv_target = targets[index]		-- make that indepent from mobj.target which may be updated
						v.silv_chase = silv_battleGT() and 2 or TICRATE	-- only 2 frames of homing time in battlemod
						table.insert(mo.silv_thrown, v)
						v.silv_grabbed = nil				-- we aren't being grabbed anymore, meaning silvers can retaliate against one another :P
						table.remove(mo.silv_telekinesis, k)
						mo.silv_selectiontimer = 0
						k = $-1
					end
				end

				if not #mo.silv_telekinesis
					-- if we're standing still and threw EVERYTHING, reset our state
					if mo.state == S_PLAY_WAIT
						mo.state = S_PLAY_STND
					end
					silv_setUseDelay(mo, TICRATE)	-- we threw everything, set a proper delay
				end
			end
			mo.silv_firehold = true
		end
	elseif mo.silv_tossflag == 1
	or (silv_gotFlag(p) and not silv_battleGT())
	or (mo.silv_holdplayer and mo.silv_energy <= 1)
		if mo.silv_holdplayer
			silv_setUseDelay(mo, TICRATE)
		end
		silv_droptelekinesis(p, not (silv_gotFlag(p) and not silv_battleGT()) and mo.silv_selection or 0)
	else
		mo.silv_firehold = nil
	end

	mo.silv_holdplayer = 0
	-- Manage our tables...
	-- Manage our held objects...
	-- Iterate backwards, you never know when an object is to disappear

	if mo.silv_telekinesis and #mo.silv_telekinesis

		p.pflags = $|PF_WPNDOWN		-- can't fire
		mo.silv_noidlebuffer = true	-- used to set you to your standing frames after using telekinesis
		silv_spawnAura(p)

		-- make sure you can't turn super in that state
		if not p.powers[pw_super]
		and P_IsObjectOnGround(mo)
			p.charflags = $ & ~SF_SUPER
		end

		-- if we're standing still, set to idle state right away
		if mo.state == S_PLAY_STND
			mo.state = S_PLAY_WAIT
		end

		local k = #mo.silv_telekinesis
		local i = 1

		local twod = (mo.flags2 & MF2_TWOD or mapheaderinfo[gamemap].typeoflevel & TOL_2D)
		local baseangle = (mo.angle + (ANGLE_11hh/2)*(#mo.silv_telekinesis-1))
		local dist = FixedMul(320*FRACUNIT, mo.scale) / FRACUNIT -- distance (320, or 64 in volley)
		while k
			local v = mo.silv_telekinesis[k]
			if not (v and v.valid and v.health)			-- don't attempt to do anything with those
			or v and v.valid and v.player and v.player.mo and (P_PlayerInPain(v.player) or (v.player and v.player.mo.silv_holdtossflag == 1 and friendlyPlayer(p, v.player)))
			or v and v.valid and R_PointToDist2(v.x, v.y, mo.x, mo.y) > FixedMul(MAX_TELEKINESIS_RANGE, mo.scale)
			or v and v.valid and v.player and v.player.powers[pw_carry]	-- don't want this
			or v and v.valid and v.player and friendlyPlayer(mo.player, v.player) and silv_gotFlag(v.player)
				silv_resetObject(v)
				table.remove(mo.silv_telekinesis, k)
				k = $-1
				i = $+1
				continue
			end

			-- get color for overlay depending on selection:
			local clr = silv_auracolor(p)
			v.silv_passcolor_noselection = clr
			local fullbright
			if mo.silv_selection > 0
				if mo.silv_selection == k	-- i-1 because we increment it
				and mo.silv_selectiontimer%10 < 5
				and p == displayplayer
					clr = ColorOpposite($)
					fullbright = true
					P_SpawnLockOn(p, v, S_LOCKON_SILV)
				end
			end
			v.silv_passcolor = clr

			-- special thinkers:
			silv_execExtra(v, "grabf", v, mo)

			v.flags = $|MF_SLIDEME	-- this helps
			local heightfac = 1
			if mo.eflags & MFE_VERTICALFLIP then heightfac = -1 end
			local target_angle, tx, ty, tz
			
			local aiming = p.aiming			
			if silv_battleGT()
				aiming = 0
			end	
			
			if not twod
				target_angle = baseangle - ANGLE_11hh*(k-1)	-- i hate angulz
				tx, ty = mo.x + dist*FixedMul(cos(target_angle), cos(aiming)), mo.y + dist*FixedMul(sin(target_angle), cos(p.aiming/2))
				tz = mo.z + (mo.height*heightfac) + dist * sin(aiming) + (v.height*heightfac)
			else	-- who the fuck still plays 2d...
				baseangle = ANGLE_11hh/2
				dist = FixedMul(128*FRACUNIT, mo.scale) / FRACUNIT -- lower the dist in 2d
				target_angle = baseangle + ANG1*25*(k-1)	-- i hate angulz
				tx, ty = mo.x + dist*FixedMul(cos(mo.angle), cos(target_angle)), mo.y + dist*FixedMul(sin(mo.angle), cos(target_angle))
				tz = mo.z + (mo.height*heightfac) + dist * sin(target_angle) + (v.height*heightfac)
				v.flags = $|MF_NOCLIPHEIGHT
			end

			-- height variation for cuteness (tm) and rollangle stuff
			tz = $+ 8*sin((leveltime + (v.silv_zoffs or 0))*ANG1*3)
			if not silv_getExtra(v, "noroll")
			and not silv_norollangle.value	-- performance consvar
				v.rollangle = $+ (v.silv_roll or 0)
			end

			if v.type == MT_PLAYER
				v.state = S_PLAY_FALL
				if v.player
					v.player.normalspeed = 0
					v.player.jumpfactor = 0
					v.player.pflags = $ & ~PF_JUMPED
					v.player.pflags = $ | PF_THOKKED
				end

				if not friendlyPlayer(p, v.player)	-- friendly players are okay
					mo.silv_holdplayer = v.eflags & MFE_UNDERWATER and 7 or 1	-- :ultraLOL:
				end
			end

			v.silv_chase = nil
			v.silv_target = nil	-- make sure those are nil for further instructions...

			local div = v.type == MT_PLAYER and 17 or 12

			v.momx = mo.momx + (tx - v.x) / div
			v.momy = mo.momy + (ty - v.y) / div
			v.momz = mo.momz + (tz - v.z) / div

			v.silv_grab = p		-- last silver player who grabbed us. (this is nil after we touch the ground.)

			local hitbox = P_SpawnMobj(v.x, v.y, v.z, MT_PSYHITBOX)
			hitbox.target = v
			hitbox.radius = v.radius + v.radius/2
			hitbox.height = v.height + v.height/2
			hitbox.tracer = mo
			hitbox.tics = 1
			hitbox.mass = 69

			k = $-1
			i = $+1
			--if (v.player and v.player == lp) and not (camchase) then continue end

			-- spawn an overlay relative to the camera

			local ref = v
			local count = 0
			while ref
				count = $+1
				local an = R_PointToAngle(ref.x, ref.y) + ANGLE_180
				local x, y = cos(an), sin(an)
				local overlay = P_SpawnMobjFromMobj(ref, x, y, 0, MT_THOK)
				if splitscreen
					silv_tp(overlay, ref.x, ref.y, overlay.z)
				end
				overlay.target = v
				overlay.z = v.z
				--overlay.state = ref.state
				if not overlay or not overlay.valid break end	-- oops
				overlay.fuse = 1
				overlay.tics = ref.tics
				overlay.scale = ref.scale
				if ref.player
					overlay.angle = ref.player.drawangle
				else
					overlay.angle = ref.angle
				end
				overlay.rollangle = ref.rollangle
				overlay.color = clr
				overlay.colorized = true
				overlay.height = ref.height
				overlay.radius = ref.radius

				overlay.eflags = $ | v.eflags & MFE_VERTICALFLIP
				overlay.flags2 = $ | v.flags2 & MF2_OBJECTFLIP

				if ref.skin
					overlay.skin = ref.skin	-- useful for 1ups I guess
				end
				local tr = (5*FRACUNIT + (2*sin(leveltime*ANG1*16)))/FRACUNIT
				overlay.sprite = ref.sprite
				overlay.sprite2 = ref.sprite2
				overlay.frame = (ref.frame & FF_FRAMEMASK)|FF_FULLBRIGHT|(tr<<FF_TRANSSHIFT)

				if ref.player and ref.player == lp and not camchase
					overlay.flags2 = $|MF2_DONTDRAW
				end

				if FixedHypot(ref.momx, ref.momy)
				and leveltime%2
					local g = P_SpawnGhostMobj(ref)
					g.color = silv_auracolor(p)
					g.fuse = 4
					g.rollangle = ref.rollangle
					g.height = ref.height
					g.radius = ref.radius
					g.colorized = true
				end

				if ref.player
					ref = ref.player.followmobj
				else
					ref = nil
				end
			end
		end
	elseif (not mo.silv_floatstate or mo.silv_floatstate and mo.silv_floatstate > 2)
	and (p.panim ~= PA_RUN or p.powers[pw_super])
	and (mo.state ~= S_PLAY_EDGE)
	and (mo.state ~= S_PLAY_WAIT)
	and not (silv_battleGT() and p.actiontime and p.actiontime > TICRATE*3)
		silv_despawnAura(p)
	end

	if mo.silv_telekinesis and not #mo.silv_telekinesis
		if skins[mo.skin].flags & SF_SUPER
			p.charflags = $|SF_SUPER	-- make sure you *can* turn super otherwise
		end
	end

	-- Manage our thrown objects
	-- Iterate through the table backwards as it is prone to have elements removed from it at any time.
	if mo.silv_thrown and #mo.silv_thrown
		local k = #mo.silv_thrown
		while k

			local v = mo.silv_thrown[k]

			if (not (v and v.valid and v.health)) or (P_IsObjectOnGround(v) and not v.silv_target and not silv_getExtra(v, "killonfloor")) or v.silv_grabbed
			and not (v and v.valid and P_CheckDeathPitCollide(v) and v.health)
			or v and v.valid and v.player and P_PlayerInPain(v.player)
			or v and v.valid and v.player and v.player.powers[pw_carry]	-- don't want this
			or (v.info.flags & MF_MISSILE and v.state == v.info.deathstate)

				if v and v.valid and not v.silv_grabbed	-- don't reset the object in that case though
					silv_resetObject(v)
				end
				table.remove(mo.silv_thrown, k)
				k = $-1
				continue
			end
			if v.type == MT_PLAYER
				v.state = S_PLAY_PAIN
				if v.player
					v.player.normalspeed = 0
					v.player.jumpfactor = 0
					v.player.pflags = $ & ~PF_JUMPED
					v.player.pflags = $ | PF_THOKKED
				end
			end

			silv_execExtra(v, "throwf", v, mo)

			if not (v.info.flags & MF_SLIDEME)
				v.flags = $ & ~MF_SLIDEME
			end
			if v.info.flags & MF_MISSILE
				v.flags = v.info.flags
				v.target = mo
			else
				v.flags = $|MF_NOCLIPTHING
			end
			v.flags = $ & ~MF_MONITOR
			v.flags = $ & ~MF_SHOOTABLE

			-- spawn hitbox (it handles the damagening for us)
			local hitbox = P_SpawnMobj(v.x + v.momx/2, v.y + v.momy/2, v.z + v.momz/2, MT_PSYHITBOX)
			hitbox.target = v
			hitbox.radius = 24*FRACUNIT
			hitbox.height = 48*FRACUNIT
			hitbox.tracer = mo
			hitbox.tics = 1
			hitbox.silv_thrown = true
			v.throwitem = hitbox

			-- follow our target?
			if v.silv_chase
				if v.silv_target and v.silv_target.valid and v.silv_target.health	-- do not attempt to rape a puff of smoke that is the remanents of enemies

					--A_HomingChase crashes on certain conditions... Because? So let's write our own:
					local dist = P_AproxDistance(P_AproxDistance(v.silv_target.x - v.x, v.silv_target.y - v.y), v.silv_target.z - v.z)
					dist = max($, 1)
					v.angle = R_PointToAngle2(v.x, v.y, v.silv_target.x, v.silv_target.y)
					local speedmul = 75*v.scale
					v.momx = FixedMul(FixedDiv(v.silv_target.x - v.x, dist), speedmul)
					v.momy = FixedMul(FixedDiv(v.silv_target.y - v.y, dist), speedmul)
					v.momz = FixedMul(FixedDiv((v.silv_target.z + v.silv_target.height/2) - v.z, dist), speedmul)			-- Merely a copypaste of the C function lmao
				end
				v.silv_chase = $-1
			end

			-- wall detection!
			if silv_blockingWall(v, nil, true)	-- oof
			or (P_IsObjectOnGround(v) and (silv_getExtra(v, "killonfloor") or v.silv_target or (v.flags & MF_MISSILE and not (v.flags & MF_GRENADEBOUNCE))))
				P_SetObjectMomZ(v, 3*v.scale)
				silv_resetObject(v)
				if not v or not v.valid continue end	-- this can happen!
				local hb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSYHITBOX)
				hb.wallthrow = true
				hb.fuse = 2
				hb.target = mo

				if not silv_getExtra(v, "nodamage")
					if v.info.flags & MF_MONITOR and v.health
						P_DamageMobj(v, mo, mo)	-- The monitor will not break otherwise.
						v.health = 0			-- failsafe
					elseif not (v.info.flags & MF_MONITOR)
						local dstate = v.flags
						v.flags = $ | MF_SHOOTABLE
						if v.health
							if not v.player or not friendlyPlayer(p, v.player)
								v.cbw_forcedmg = mo
								P_DamageMobj(v, hb, mo)	-- It causes oddities otherwise. Man, fuck this game, sometimes.
								if v and v.valid
									v.cbw_forcedmg = nil
								end
							end
						end
						if v and v.valid
							v.flags = dstate
						end
					end
				end

				-- weird special case?
				if silv_getExtra(v, "killonwall") and not P_IsObjectOnGround(v)
					P_KillMobj(v, hb, mo)
				end

				silv_fillGauge(mo.player, SILVER_MAX_ENERGY/15)
				table.remove(mo.silv_thrown, k)
				explodeTK(v)
				k = $-1
				continue
			end
			-- spawn trail
			if leveltime%2
				--v.scale = mo.scale/2	-- test
				local overlay = P_SpawnGhostMobj(v)
				--overlay.tics = 4
				--overlay.scale = v.scale*3/2
				overlay.destscale = v.scale*3/2
				overlay.radius = v.radius
				overlay.height = v.height
				overlay.rollangle = v.rollangle
				overlay.color = silv_auracolor(p)
				overlay.colorized = true
			end
			k = $-1
		end
	end

	if not #mo.silv_telekinesis
	and mo.silv_noidlebuffer
		if mo.state == S_PLAY_WAIT
			mo.state = S_PLAY_STND
		end
		mo.silv_noidlebuffer = nil
	end
end)

rawset(_G, "silv_generalPlayerThinker", function(p)	-- we're not actually silver?
	if p and (p.spectator or not p.mo)	-- whatever
		if p.silv_saveskin
			p.normalspeed = skins[p.silv_saveskin].normalspeed
			p.jumpfactor = skins[p.silv_saveskin].jumpfactor	-- avoid having spectators being stuck in an endless limbo
			--R_SetPlayerSkin(p, p.silv_saveskin)
			p.silv_saveskin = nil
		end
	end
	if p and p.mo

		p.mo.silv_alive = $ and $+1 or 1	-- used for hud.
		p.silv_saveskin = p.mo.skin	-- this is for spectating
		-- some more thinker for players
		local mo = p.mo
		mo.silv_alivetime = mo.silv_alivetime ~= nil and $+1 or 0	-- used for not throwing stuff as you respawn
		if P_IsObjectOnGround(mo)
			if not mo.silv_ongroundtime then mo.silv_ongroundtime = 0 else mo.silv_ongroundtime = $+1 end
			if mo.silv_ongroundtime >= 2 then mo.silv_grab = nil end	-- reset last grabber
		else
			mo.silv_ongroundtime = nil
		end

		if p.cmd.buttons & BT_TOSSFLAG and p.mo.silv_holdtossflag ~= nil
			p.mo.silv_holdtossflag = $+1
		else
			p.mo.silv_holdtossflag = 0
		end
	end
	if p and p.mo and (p.charability ~= 69) and p.mo.silv_telekinesis
		p.mo.silv_telekinesis = nil
		p.mo.silv_idlemobjs = nil
		p.mo.silv_thrown = nil
		p.mo.silv_energy = nil
		p.mo.silv_usedelay = nil
		p.mo.silv_pusedelay = nil
	end
end)

-- if damaged (or killed), we should drop our items
local function silv_dropobj(mo)

	if not mo or not mo.valid return end
	if mo.skin == "silver"
	and gametyperules & GTR_RINGSLINGER|GTR_DEATHMATCHSTARTS	-- ringslinger / battle
	and not silv_battleGT()
		silv_setUseDelay(mo, TICRATE*2)
	end

	if mo and mo.silv_telekinesis and #mo.silv_telekinesis and mo.player and mo.player.valid
		silv_droptelekinesis(mo.player)
	end
	if not mo or not mo.valid return end
	-- free ourselves from telekinesis if we got hurt somehow
	if mo.silv_grab and mo.silv_grab.valid
	and mo.silv_grab.mo and mo.silv_grab.mo.valid
	and mo.silv_grab.mo.silv_telekinesis	-- i hate having to check for so much

		mo.silv_damagep = mo.silv_grab

		for k,v in ipairs(mo.silv_grab.mo.silv_telekinesis)
			if v == mo
				silv_resetObject(v)
				if mo.silv_grab and mo.silv_grab.mo and mo.silv_grab.mo.silv_telekinesis
					table.remove(mo.silv_grab.mo.silv_telekinesis, k)
				end
			end
		end
	end
	if not mo or not mo.valid return end
	-- remove ourselves from the thrown table as well if we happen to be in it
	if mo.silv_grab and mo.silv_grab.valid
	and mo.silv_grab.mo and mo.silv_grab.mo.valid
	and mo.silv_grab.mo.silv_thrown

		mo.silv_damagep = mo.silv_grab

		for k,v in ipairs(mo.silv_grab.mo.silv_thrown)
			if v == mo
				silv_resetObject(v)
				if mo.silv_grab and mo.silv_grab.mo and mo.silv_grab.mo.silv_thrown
					table.remove(mo.silv_grab.mo.silv_thrown, k)
				end
			end
		end
	end
end
addHook("MobjDamage", silv_dropobj, MT_PLAYER)
addHook("MobjDeath", silv_dropobj, MT_PLAYER)

-- don't damage ourselves or our friends with our held items...
addHook("ShouldDamage", function(mo, e)
	if (e and e.valid and (e.silv_grabbed and e.silv_grab or e.thrownitem and e.thrownitem.valid) and friendlyPlayer(mo.player, e.silv_grab))
		return false
	end
end, MT_PLAYER)

-- make thrown stuff damage stuff.
local function silv_tkcollide(mo, e)
	if not mo or not mo.valid then return end
	if not mo.silv_thrown then return end
	if e.silv_grabbed then return end
	if not (mo.z + mo.height >= e.z and mo.z <= e.z+e.height) then return end	-- make sure there's vertical contact, this time around...

	if not (e.flags & (MF_SHOOTABLE|MF_SOLID|MF_ENEMY|MF_MISSILE)) and e.type ~= MT_PLAYER then
		return false
	end	-- don't collide with unrelated garbage.

	if not mo.target or not mo.target.valid or not mo.target.health then
		P_RemoveMobj(mo)
	return end

	if e and e.valid and e ~= mo.target and e ~= mo.tracer
	and not e.silv_chase and not (e.throwitem and e.throwitem.valid)
		if not (e.type == MT_PLAYER and friendlyPlayer(mo.tracer.player, e.player))
			for k,v in ipairs(mo.tracer.silv_telekinesis)	-- remove object from the Telekinesis table:
				if v == mo.target
					table.remove(mo.tracer.silv_telekinesis, k)
				end
			end
			mo.tracer.silv_throwcombo = $+1
			local amount = (SILVER_MAX_ENERGY / 8)*mo.tracer.silv_throwcombo
			silv_fillGauge(mo.tracer.player, amount)
			if mo.target and mo.target.kill	-- ngl that's a silly hack to fuck Inazuma over
				P_KillMobj(e, mo.target or mo, mo.tracer or mo)
				if e.player	-- for some reason it doesn't work on its own I don't really get it
					print(e.player.cname.." was decimated by "..mo.tracer.player.cname.."'s deflected Lightning Blast!")
					P_AddPlayerScore(mo.tracer.player, 100)
				end
			else
				if e.health

					local inf, source
					inf = mo.target or mo
					source = (mo.tracer.player and mo.tracer.player.bot) and players[0].mo or (mo.tracer or mo)

					if not (silv_battleGT() and e.player and e.player.battle_def > 0 and mo.type != MT_PLAYER)
					-- do not damage if we're in battlemod, and e is a player with positive defence
					-- unless we're throwing another player (lol)
						e.cbw_forcedmg = source
						
						-- for battlemod, we must set inf's priority.
						if inf.type == MT_PLAYER
						and silv_battleGT()
							CBW_Battle.SetPriority(inf.player, 4, 4, nil, 4, 4, "thrown body")
						end
						
						P_DamageMobj(e, inf, source)	
						e.cbw_forcedmg = nil
					else
						-- knock them out:
						local player = e.player
						player.panim = PA_FALL
						e.state = S_PLAY_FALL
						player.pflags = $ & ~(PF_GLIDING|PF_JUMPED|PF_BOUNCING|PF_THOKKED|PF_SPINNING)
						e.momx = mo.target.momx/2
						e.momy = mo.target.momy/2
						e.momz = mo.target.momz/2
						e.recoilthrust = FixedHypot(mo.momx, mo.momy)
						S_StartSound(e, sfx_s3k5f)
					end

					if e.flags & MF_MONITOR
					and not (e.flags & MF_GRENADEBOUNCE)	-- not with golden TVs
						e.health = 0	-- make sure
					end
				end
			end
			if mo.target and mo.target.valid and e and e.valid
			and not silv_getExtra(mo.target, "nodamage")
				if mo.target.info.flags & MF_SHOOTABLE and mo.target.health	-- make sure it's not already dead
					mo.target.flags = mo.target.info.flags
					P_InstaThrust(mo.target, 0, 0)
					mo.target.rollangle = 0
					
					if mo.target.type != MT_PLAYER
					or not friendlyPlayer(mo.tracer.player, mo.target.player)
						P_DamageMobj(mo.target, mo.tracer, mo.tracer)
					end	

					if not mo.target or not mo.target.valid
						P_RemoveMobj(mo)
						return	-- I guess its deathsate was S_NULL
					end
					if mo.target.info.flags & MF_MONITOR		-- make sure
						mo.target.health = 0
						if mo.target.spawnpoint and mo.target.spawnpoint.valid
							/*
								MOVED TO silv_itemRespawnQueue
							local x, y = mo.target.spawnpoint.x<<FRACBITS, mo.target.spawnpoint.y<<FRACBITS
							local floorz = R_PointInSubsector(x, y).sector.floorheight
							local flip = 2
							local zpos = floorz + (mo.target.spawnpoint.z<<FRACBITS)*(mo.target.spawnpoint.options & flip and -1 or 1)

							silv_tp(mo.target, x, y, zpos)*/
						end
					end
				elseif not (mo.info.flags & MF_MONITOR)	-- failsafe
					P_KillMobj(mo.target, mo, mo.tracer)
				end
			end
			if not mo.target or not mo.target.valid	-- target died!
				P_RemoveMobj(mo)
				return
			end

			explodeTK(mo.target)

			if mo.target and mo.target.valid and mo.target.player	-- what we're holding is a player!
			and friendlyPlayer(mo.tracer.player, mo.target.player)	-- compare affinity between the 2 players
				-- if they're friends, roll away
				P_SetObjectMomZ(mo.target, FRACUNIT*5)
				mo.target.player.pflags = $|PF_SPINNING
				mo.target.momx = $/4
				mo.target.momy = $/4
				mo.target.state = S_PLAY_ROLL
			end
		end
	end
end
--addHook("MobjCollide", silv_tkcollide, MT_PSYHITBOX)
addHook("MobjMoveCollide", silv_tkcollide, MT_PSYHITBOX)

-- hack....
addHook("ShouldDamage", function(mo)
	if mo and mo.valid and mo.cbw_forcedmg
		if mo.cbw_forcedmg.player and not friendlyPlayer(mo.cbw_forcedmg, mo.player)
			return true
		end
	end
end, MT_PLAYER)


-- handle held items for some stuff
addHook("MobjThinker", function(h)
	local mo = h.target
	local pmo = h.tracer

	if not pmo or not pmo.valid or pmo.player.charability ~= 69	-- NANI
		silv_resetObject(mo)
	end
end, MT_PSYHITBOX)

local tkextra_fieldchecks = {
["nograb"] = "boolean",
["noaim"] = "boolean",
["shield"] = "number",
["nodamage"] = "boolean",
["killonwall"] = "boolean",
["killonfloor"] = "boolean",
["bossdamage"] = "boolean",
["msondamage"] = "boolean",
["boostbump"] = "boolean",
["boostcf"] = "function",
["grabf"] = "function",
["shieldf"] = "function",
["throwf"] = "function",
}

rawset(_G, "silv_addTKextra", function(mobjtype, t)
	assert(mobjtype, "silv_addTKextra: No mobjtype supplied")
	assert(t, "silv_addTKextra: No data supplied")

	-- check table
	for k, v in pairs(t)
		if tkextra_fieldchecks[k]
			assert(type(v) == tkextra_fieldchecks[k], "silv_addTKextra: Mobjtype "..mobjtype..": Wrong variable type for field \'"..k.."\', expected "..tkextra_fieldchecks[k]..", got "..type(v)..".")
		end
	end

	silv_TKextra[mobjtype] = t
	print("Added mobjtype "..mobjtype.." to Telekinesis Extra Data table.")
end)

-- Finally, set the hurtmsg for match

local TVname = {
	[MT_RING_BOX] = "Super Ring Monitor",
	[MT_RING_REDBOX] = "Super Ring Monitor",
	[MT_RING_BLUEBOX] = "Super Ring Monitor",
	[MT_SNEAKERS_BOX] = "Super Sneakers Monitor",
	[MT_INVULN_BOX] = "Invincibility Monitor",
	[MT_1UP_BOX] = "1-Up Monitor",
	[MT_PITY_BOX] = "Pity Shield Monitor",
	[MT_ATTRACT_BOX] = "Attraction Shield Monitor",
	[MT_FORCE_BOX] = "Force Shield Monitor",
	[MT_WHIRLWIND_BOX] = "Whirlwind Shield Monitor",
	[MT_ARMAGEDDON_BOX] = "Armageddon Shield Monitor",
	[MT_ELEMENTAL_BOX] = "Elemental Shield Monitor",
	[MT_FLAMEAURA_BOX] = "Flame Shield Monitor",
	[MT_BUBBLEWRAP_BOX] = "Bubble Shield Monitor",
	[MT_THUNDERCOIN_BOX] = "Electric Barrier Monitor",
	[MT_EGGMAN_BOX] = "Eggman Monitor",
	[MT_MIXUP_BOX] = "Mix-Up Monitor",
	[MT_RECYCLER_BOX] = "Recycler Monitor",
	[MT_GRAVITY_BOX] = "Gravity Boots Monitor",
	[MT_SCORE1K_BOX] = "Score Monitor",
	[MT_SCORE10K_BOX] = "Score Monitor",
	[MT_MYSTERY_BOX] = "Random Monitor",

	[MT_SNEAKERS_GOLDBOX] = "Super Sneakers Monitor",
	[MT_INVULN_GOLDBOX] = "Invincibility Monitor",
	[MT_PITY_GOLDBOX] = "Pity Shield Monitor",
	[MT_ATTRACT_GOLDBOX] = "Attraction Shield Monitor",
	[MT_FORCE_GOLDBOX] = "Force Shield Monitor",
	[MT_WHIRLWIND_GOLDBOX] = "Whirlwind Shield Monitor",
	[MT_ARMAGEDDON_GOLDBOX] = "Armageddon Shield Monitor",
	[MT_ELEMENTAL_GOLDBOX] = "Elemental Shield Monitor",
	[MT_FLAMEAURA_GOLDBOX] = "Flame Shield Monitor",
	[MT_BUBBLEWRAP_GOLDBOX] = "Bubble Shield Monitor",
	[MT_THUNDERCOIN_GOLDBOX] = "Electric Barrier Monitor",
	[MT_EGGMAN_GOLDBOX] = "Eggman Monitor",
	[MT_GRAVITY_GOLDBOX] = "Gravity Boots Monitor"
}

local function isdead(p)
	return (p.mo.health <= 0 and not (p.powers[pw_shield] or p.powers[pw_invulnerability]))
end

rawset(_G, "silv_memeDamage", function(mo, target)

	local memeseed = P_RandomRange(0, 2)
	if not silv_meme() return end

	if target.player
	and skins[target.skin].name:lower():find("sonic")
	and isdead(target.player)
		S_StartSound(mo, sfx_skills)
	else
		S_StartSound(mo, sfx_skill1+memeseed)
	end
end)

local cutname = {
	[WEP_AUTO] = " Automatic ",
	[WEP_BOUNCE] = " Bounce ",
	[WEP_RAIL] = " Rail ",
	[WEP_SCATTER] = " Scatter ",
	[WEP_EXPLODE] = " Explosion ",
	[WEP_GRENADE] = " Grenade ",
}

-- for players:
addHook("MobjDeath", function(mo)
	if not mo or not mo.valid return end
	if mo.player
		mo.player.normalspeed = skins[mo.skin].normalspeed
		mo.player.jumpfactor = skins[mo.skin].jumpfactor
	end
end, MT_PLAYER)

addHook("HurtMsg", function(p, inflictor, source)
	if not p.mo return end
	if not p.cname return end
	local mo = p.mo

	local holdp = mo.silv_damagep

	if not inflictor and holdp
		if isdead(p) or P_CheckDeathPitCollide(mo)
			if P_CheckDeathPitCollide(mo)
				P_AddPlayerScore(holdp, 50)
			else
				P_AddPlayerScore(holdp, 100)
			end
		else
			print(holdp.cname.." has thrown "..p.cname.." into some hazard.")
			P_AddPlayerScore(holdp, 50)
		end
		silv_memeDamage(holdp.mo, mo)
		silv_resetObject(mo)
		mo.silv_grab = nil
		mo.silv_damagep = nil
		holdp = nil
		return true
	elseif holdp and not inflictor.wallthrow and not mo.wallthrow	-- hurt while held
		if isdead(p)
			if mo.eflags & MFE_UNDERWATER and p.powers[pw_underwater] <= 1
				print(holdp.cname.." savagely drowned "..p.cname..".")
				--P_AddPlayerScore(holdp, 50)
			else
				print(holdp.cname.." killed "..p.cname.." by dragging them around.")
			end
			--P_AddPlayerScore(holdp, 100)
		else
			print(holdp.cname.." hurt "..p.cname.." by dragging them around.")
			--P_AddPlayerScore(holdp, 50)
		end
		silv_memeDamage(holdp.mo, mo)
		silv_resetObject(mo)
		mo.silv_damagep = nil
		holdp = nil
		mo.silv_grab = nil
		return true
	elseif inflictor and inflictor.type == MT_PSYCHOCUT	-- Psychic Knife... thing
		local name = (cutname[inflictor.weapon] or " Psycho ").."Cut "
		if isdead(p)
			print(inflictor.target.player.cname.."'s"..name.."killed "..p.cname..".")
		else
			print(inflictor.target.player.cname.."'s"..name.."hit "..p.cname..".")
		end
		silv_memeDamage(inflictor.target, p.mo)
		return true
	elseif inflictor and not (inflictor.flags & MF_MISSILE) and inflictor.throwitem and inflictor.throwitem.valid	-- thrown item hit us

		local line = "'s thrown junk"
		if inflictor.info.flags & MF_MONITOR
			line = "'s thrown "..(TVname[inflictor.type] or "Monitor")
		elseif inflictor.type == MT_PLAYER
			line = " has thrown "..inflictor.player.cname
		end

		if isdead(p)
			if inflictor.type == MT_PLAYER
				print(inflictor.throwitem.tracer.player.cname..line.." into and killed "..p.cname..".")
			else
				print(inflictor.throwitem.tracer.player.cname..line.." killed "..p.cname..".")
			end
		else
			if inflictor.type == MT_PLAYER
				print(inflictor.throwitem.tracer.player.cname..line.." into and hit "..p.cname..".")
			else
				print(inflictor.throwitem.tracer.player.cname..line.." hit "..p.cname..".")
			end
		end
		silv_memeDamage(inflictor.throwitem.tracer, p.mo)
		return true
	elseif inflictor and inflictor.valid and inflictor.wallthrow								-- delicious wall pancake
		if isdead(p)
			print(source.player.cname.." splattered "..p.cname.." into a wall, killing them.")
		else
			print(source.player.cname.." hit "..p.cname.." against a wall.")
		end
		silv_memeDamage(source, p.mo)
		return true
	elseif inflictor and inflictor.type == MT_PLAYER and mo.throwitem and mo.throwitem.valid	-- hit by throw recoil
		if isdead(p)
			print(p.cname.." was killed by the recoil after being thrown by "..inflictor.player.cname)
		else
			print(p.cname.." was hit by the recoil after being thrown by "..inflictor.player.cname)
		end
		silv_memeDamage(inflictor, p.mo)
		return true
	elseif inflictor and inflictor.type == MT_PLAYER and inflictor.floatstate and inflictor.floatstate == 2	-- psycho boost
		if isdead(p)
			print(p.cname.." was pierced to death by "..inflictor.player.cname.."'s Psycho Boost.")
		else
			print(p.cname.." was hit by "..inflictor.player.cname.."'s Psycho Boost.")
		end
	end
end)

for i = 0, #mobjinfo-1
	if mobjinfo[i] and mobjinfo[i].flags & MF_MONITOR
		addHook("MobjDeath", function(mo)
			if (CV_FindVar("respawnitem").value and G_RingSlingerGametype() or silv_battleGT())
				silv_addToRespawnQueue(mo, min(10*TICRATE, CV_FindVar("respawnitemtime").value*TICRATE))
			end
		end, i)
		
		silv_TKextra[i] = {
			resetf = 	function(mo)
							if (CV_FindVar("respawnitem").value and G_RingSlingerGametype() or silv_battleGT())
								silv_addToRespawnQueue(mo, min(10*TICRATE, CV_FindVar("respawnitemtime").value*TICRATE))
							end	
						end,
		}
	end
end

if respawnitemqueue_debug
hud.add(function(v, p, c)
	
	for i = 1, #silv_respawnqueue
		local t = silv_respawnqueue[i]
		
		v.drawString(310, 10+ (i-1)*10, tostring(t[1])..", "..tostring(t[2]), 0, "right")
	end
end)
end

